var bibmasDomTableHeader=document.getElementById("bibmasmaintable").getElementsByTagName("thead")[0];
var d4t4c3ll1nd3x=bibmasDomTableHeader.getElementsByClassName('d4t4')[0].cellIndex;
var sortkeycellindex=bibmasDomTableHeader.getElementsByClassName('sortkeycolumn')[0].cellIndex;
var entrykeycellindex=bibmasDomTableHeader.getElementsByClassName('entrykeycolumn')[0].cellIndex;


//http://jmrware.com/articles/2010/linkifyurl/linkify.html

/* <![CDATA[ */
/* File:        linkify.js
 * Version:     20101010_1000
 * Copyright:   (c) 2010 Jeff Roberson - http://jmrware.com
 * MIT License: http://www.opensource.org/licenses/mit-license.php
 *
 * Summary: This script linkifys http URLs on a page.
 *
 * Usage:   See demonstration page: linkify.html
 */
 
function linkify(text) {
    /* Here is a commented version of the regex (in PHP string format):
    $url_pattern = '/# Rev:20100913_0900 github.com\/jmrware\/LinkifyURL
    # Match http & ftp URL that is not already linkified.
      # Alternative 1: URL delimited by (parentheses).
      (\()                     # $1  "(" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $2: URL.
      (\))                     # $3: ")" end delimiter.
    | # Alternative 2: URL delimited by [square brackets].
      (\[)                     # $4: "[" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $5: URL.
      (\])                     # $6: "]" end delimiter.
    | # Alternative 3: URL delimited by {curly braces}.
      (\{)                     # $7: "{" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $8: URL.
      (\})                     # $9: "}" end delimiter.
    | # Alternative 4: URL delimited by <angle brackets>.
      (<|&(?:lt|\#60|\#x3c);)  # $10: "<" start delimiter (or HTML entity).
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $11: URL.
      (>|&(?:gt|\#62|\#x3e);)  # $12: ">" end delimiter (or HTML entity).
    | # Alternative 5: URL not delimited by (), [], {} or <>.
      (                        # $13: Prefix proving URL not already linked.
        (?: ^                  # Can be a beginning of line or string, or
        | [^=\s\'"\]]          # a non-"=", non-quote, non-"]", followed by
        ) \s*[\'"]?            # optional whitespace and optional quote;
      | [^=\s]\s+              # or... a non-equals sign followed by whitespace.
      )                        # End $13. Non-prelinkified-proof prefix.
      ( \b                     # $14: Other non-delimited URL.
        (?:ht|f)tps?:\/\/      # Required literal http, https, ftp or ftps prefix.
        [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]+ # All URI chars except "&" (normal*).
        (?:                    # Either on a "&" or at the end of URI.
          (?!                  # Allow a "&" char only if not start of an...
            &(?:gt|\#0*62|\#x0*3e);                  # HTML ">" entity, or
          | &(?:amp|apos|quot|\#0*3[49]|\#x0*2[27]); # a [&\'"] entity if
            [.!&\',:?;]?        # followed by optional punctuation then
            (?:[^a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]|$)  # a non-URI char or EOS.
          ) &                  # If neg-assertion true, match "&" (special).
          [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]* # More non-& URI chars (normal*).
        )*                     # Unroll-the-loop (special normal*)*.
        [a-z0-9\-_~$()*+=\/#[\]@%]  # Last char can\'t be [.!&\',;:?]
      )                        # End $14. Other non-delimited URL.
    /imx';
    */
    var url_pattern = /(\()((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&'()*+,;=:\/?#[\]@%]+)(\))|(\[)((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&'()*+,;=:\/?#[\]@%]+)(\])|(\{)((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&'()*+,;=:\/?#[\]@%]+)(\})|(<|&(?:lt|#60|#x3c);)((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&'()*+,;=:\/?#[\]@%]+)(>|&(?:gt|#62|#x3e);)|((?:^|[^=\s'"\]])\s*['"]?|[^=\s]\s+)(\b(?:ht|f)tps?:\/\/[a-z0-9\-._~!$'()*+,;=:\/?#[\]@%]+(?:(?!&(?:gt|#0*62|#x0*3e);|&(?:amp|apos|quot|#0*3[49]|#x0*2[27]);[.!&',:?;]?(?:[^a-z0-9\-._~!$&'()*+,;=:\/?#[\]@%]|$))&[a-z0-9\-._~!$'()*+,;=:\/?#[\]@%]*)*[a-z0-9\-_~$()*+=\/#[\]@%])/img;
//    var url_replace = '$1$4$7$10$13<a href="$2$5$8$11$14">$2$5$8$11$14</a>$3$6$9$12';
//    return text.replace(url_pattern, url_replace);
//    var url_replace = '$1$4$7$10$13<a href="$2$5$8$11$14">$2$5$8$11$14</a>$3$6$9$12';
    return text.replace(url_pattern,
    		function ($0, $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14) {
	    		var len = arguments.length;
	    		for (var i = 0; i < len; ++i) {
	    			if (arguments[i] === undefined) arguments[i] = "";
	    		}
	    		var pre  = $1+$4+$7+$10+$13;
	    		var url  = $2+$5+$8+$11+$14;
	    		var post = $3+$6+$9+$12;
	    		
	    		if (allBalanced(url)) {
	    			return pre +lnkEx(url,url)+ post; //change AS: using lnkEx function instead of <a href=... string
	    		} else {
		    		// Fixup urls ending with orphan "]" or "}"
		    		switch (url.slice(-1)) {
		    		case ')':
			    		if (!parensBalanced(url)) {
			    			if (parensBalanced(url.slice(0,-1))) {
			    				url = url.slice(0,-1);
			    				post = ')'+ post
			    			}
			    		}
			    		if (!bracketsBalanced(url)) {
			    			if (bracketsBalanced(url.slice(0,-1))) {
			    				url = url.slice(0,-1);
			    				post = ']'+ post
			    			}
			    		}
			    		break;
		    		case ']':
			    		if (!bracketsBalanced(url)) {
			    			if (bracketsBalanced(url.slice(0,-1))) {
			    				url = url.slice(0,-1);
			    				post = ']'+ post
			    			}
			    		}
			    		if (!parensBalanced(url)) {
			    			if (parensBalanced(url.slice(0,-1))) {
			    				url = url.slice(0,-1);
			    				post = ')'+ post
			    			}
			    		}
			    		break;
		    		}
	    		}
	    		if (allBalanced(url)) {
	    			return pre +lnkEx(url,url)+ post; //change AS: using lnkEx function
	    		} else return $0;
    		});
	function allBalanced(url) {
		return parensBalanced(url) && bracketsBalanced(url);
	}
	function parensBalanced(url) {
	    var re = /\([^()]*\)/g;
        while (url.search(re) !== -1) {
        	url = url.replace(re, '');
        }
		if (url.search(/[()]/) === -1) return true;
		return false;
	}
	function bracketsBalanced(url) {
	    var re = /\[[^[\]]*\]/g;
        while (url.search(re) !== -1) {
        	url = url.replace(re, '');
        }
		if (url.search(/[[\]]/) === -1) return true;
		return false;
	}

	function bracket2entity(text) {
		return text.replace(/[()[\]]/g,
			function(m0){
				return {
					'(':'&#40;',
					')':'&#41;',
					'[':'&#91;',
					']':'&#93;', }[m0];
			})
	}
	function entity2bracket(text) {
		return text.replace(/&#(?:4[01]|9[13]);/g,
			function(m0){
				return {
					'&#40;':'(',
					'&#41;':')',
					'&#91;':'[',
					'&#93;':']',
					}[m0];
			})
	}
}
function linkify_html(text) {
    text = text.replace(/&amp;apos;/g, '&#39;'); // IE does not handle &apos; entity!
    /* Here is a commented version of the regex (in PHP string format):
    $section_html_pattern = '%# Rev:20100913_0900 github.com/jmrware/LinkifyURL
    # Section text into HTML <A> tags  and everything else.
      (                              # $1: Everything not HTML <A> tag.
        [^<]+(?:(?!<a\b)<[^<]*)*     # non A tag stuff starting with non-"<".
      |      (?:(?!<a\b)<[^<]*)+     # non A tag stuff starting with "<".
      )                              # End $1.
    | (                              # $2: HTML <A...>...</A> tag.
        <a\b[^>]*>                   # <A...> opening tag.
        [^<]*(?:(?!</a\b)<[^<]*)*    # A tag contents.
        </a\s*>                      # </A> closing tag.
      )                              # End $2:
    %ix';
    */
    section_html_pattern = /([^<]+(?:(?!<a\b)<[^<]*)*|(?:(?!<a\b)<[^<]*)+)|(<a\b[^>]*>[^<]*(?:(?!<\/a\b)<[^<]*)*<\/a\s*>)/ig;
    return text.replace(section_html_pattern, _linkify_html_callback);
}
function _linkify_html_callback(m0, m1, m2) {
    if (m2) return m2;
    return linkify(m1);
}





// Safely reading a nested property 
// Ben Kitzelman, http://thecodeabode.blogspot.com.au/2013/04/javascript-safely-reading-nested.html
// Usage... for a nested structure
// var test = {
// nested: {
// value: 'Read Correctly'
// }
// };
// safeRead(test, 'nested', 'value'); // returns 'Read Correctly'
// safeRead(test, 'missing', 'value'); // returns ''
//
var safeRead = function() {
    var current, formatProperty, obj, prop, props, val, _i, _len;

    obj = arguments[0], props = 2 <= arguments.length ? [].slice.call(arguments, 1) : [];

    read = function(obj, prop) {
        if ((obj != null ? obj[prop] : void 0) == null) {
            return;
        }
        return obj[prop];
    };

    current = obj;
    for (_i = 0, _len = props.length; _i < _len; _i++) {
        prop = props[_i];

        if (val = read(current, prop)) {
            current = val;
        } else {
            return '';
        }
    }
    return current;
};



Date.prototype.yyyymmddThhmmse = function() {
    var yyyy = this.getFullYear().toString();
    var mm = (this.getMonth() + 1).toString(); // getMonth() is zero-based
    var dd = this.getDate().toString();
    var hh = this.getHours();
    var mi = this.getMinutes();
    var se = this.getSeconds();

    return [yyyy, (mm[1] ? mm : "0" + mm[0]), (dd[1] ? dd : "0" + dd[0])].join('-') + 'T' + [hh.pad(2), mi.pad(2), se.pad(2)].join('.');
};

Number.prototype.pad = function(size) {
    var s = String(this);
    if (typeof(size) !== "number") {
        size = 4;
    }

    while (s.length < size) {
        s = "0" + s;
    }
    return s;
}

/**
 * Function will get element by id starting from specified node.
 * Author: Renato Bebić <renato.bebic@gmail.com>
 *
 *function GetElementById( dNode, id ) {

	var dResult = null;

	if ( dNode.getAttribute('id') == id )
		return dNode;

	for ( var i = 0; i < dNode.childNodes.length; i++ ) {
		if ( dNode.childNodes[i].nodeType == 1 ) {
			dResult = GetElementById( dNode.childNodes[i], id );
			if ( dResult != null )
				break;
		}
	}

	return dResult;
}
*/

function slctT(elem) {
    try {
        /* http://aktuell.de.selfhtml.org/artikel/javascript/textauswahl/ */
        elem.focus()
        if (document.selection && document.selection.createRange) {
            var textRange = document.selection.createRange();
            textRange.moveToElementText(elem);
            textRange.select();
        } else if (document.createRange && window.getSelection) {
            var range = document.createRange();
            range.selectNode(elem);
            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(range);
        }

    } catch (err) {}

}


/*
 * 2017-09: ueberlegung die html datei zu verkleinern. 
 * function cAT(element){
var mycell, str;
mycell = $(element).parents('td');

	if mycell.hasClass('editorcolumn'))) 
	// richtiges Feld auslesen;
	
	// falls editor: auch editora, b c etc
	;
	 
	var author=
	name = safeRead(ArrayOfBibKeys,ky,"author");
	cTT(this,
	
	         '<ul class=au><li><cite class=author>\format[Authors(LastFirst,FullName,Sep=</cite></li><li><cite class=author>,LastSep=</cite></li><li><cite class=author>),HTMLChars]{\author}</cite></li></ul>');
	
	}
*/
function cTT(element, text, simplemode, mywidth, withoutDetails) {

    // is it not yet fancy to have tooltips with other tooltips inside
    //if ($(element).closest(".tooltiptext").length > 0) return element;
    //if ($(element).parents(".dialogInner")) simplemode=true;
    if (simplemode && withoutDetails) {
        element.setAttribute('title', stripHTML(text));
        element.setAttribute('class', element.className + ' simpleTooltip');
        element.removeAttribute('onmouseover');
        element.removeAttribute('onfocus');
        return;
    }



    //element.removeAttribute("onclick");
    if ((element.getAttribute("href") === "#z")) {

        //element.outerHTML=element.innerHTML;
        //alert(element.tagName);
        element.removeAttribute("href");
        element.removeAttribute("onclick");
    };

    if (withoutDetails) {
        element.removeAttribute("onmouseover");
        element.removeAttribute("onfocus");
    }

    //if (text.length > 100000) return;

    var NewElement = element.cloneNode(true); // copying element 

    var overallTag = document.createElement("span"); //build empty  overall tag

    switch (NewElement.tagName.toLowerCase()) {
        case "a":
            var Sniff = NewElement; //.firstChild;
            break;
        default:
            var Sniff = document.createElement("a");
            Sniff.setAttribute("name", "null");
            Sniff.appendChild(NewElement); // moving this copy into empty summary tag 
    }


    var tooltipTextTag = document.createElement("small"); //build empty  note tag
    tooltipTextTag.className = "tooltiptext";




    /*	var resize1=document.createElement("div");resize1.className="dynDiv_resizeDiv_tl"; tooltipTextTag.appendChild(resize1);
				var resize2=document.createElement("div");resize2.className="dynDiv_resizeDiv_tr"; tooltipTextTag.appendChild(resize2);
				var resize3=document.createElement("div");resize3.className="dynDiv_resizeDiv_bl"; tooltipTextTag.appendChild(resize3);
				var resize4=document.createElement("div");resize4.className="dynDiv_resizeDiv_br"; tooltipTextTag.appendChild(resize4);
  		*/



    tooltipTextTag.innerHTML = " "+linkify_html(text);
        /*'<b style="cursor: move" title="click here to move" onmousedown="' +
        'x=this.parentNode;x.style.marginTop=0;x.className+=\' dynDiv_moveDiv\';ByRei_dynDiv.add(x);' +   '" > <\/b>\n' + */
        

    if (mywidth) {
        tooltipTextTag.style.minWidth = mywidth + "!important";
        tooltipTextTag.style.width = mywidth + "!important";
        tooltipTextTag.className += " widescreen"
    }
    tooltipTextTag.style.width = "300!important";

if (NewElement.className=="mkTT") NewElement.removeAttribute("class");
//    switch (NewElement.className) {
//        case "mkTT":
//            NewElement.removeAttribute("class");
            var MyClass = "tooltip";
//            break;
//        default:
//            var MyClass = "tooltip NoI";
//    }

    if (overallTag.className.indexOf(MyClass) < 0) {
        overallTag.className += MyClass;
    }

    //var x=$(element).parents("tr").attr("id") + "_" + legalisestring(element.textContent.toLowerCase()) + "__details";
    if (!withoutDetails) {
        var detailsTag = document.createElement("details"); //build empty  details tag
        var ElementTag = document.createElement("summary"); //build empty  summary tag

        /*var showHdl="document.getElementById('"+x+"').style.display='block'!important";
			var hideHdl="document.getElementById('"+x+"').style.display='none'!important";
			*/
        $(ElementTag).on("focus", function() {
                $(this).parents(".tooltip").attr("selectedsummary", "true")
            })
            .on("blur", function() {
                $(this).parents(".tooltip").removeAttr("selectedsummary")
            });

        ElementTag.appendChild(Sniff);
        //ElementTag.appendChild(tooltipTextTag)
        detailsTag.appendChild(ElementTag); // move empty summary tag into details tag
        detailsTag.setAttribute("open", "open");
        //  detailsTag.setAttribute("onmousemove", "this.setAttribute('open','')");
        overallTag.appendChild(detailsTag);
        var detailsTextTag = tooltipTextTag.cloneNode(true);
        detailsTextTag.removeAttribute("class");
        detailsTag.appendChild(detailsTextTag); // move NOTE tag into details tag
    } else {
        overallTag.appendChild(Sniff)

    }
    overallTag.appendChild(tooltipTextTag);
    //tooltipTextTag.id=x;


    //ByRei_dynDiv.add(resize1);ByRei_dynDiv.add(resize2);ByRei_dynDiv.add(resize3);ByRei_dynDiv.add(resize4);

    element.parentNode.replaceChild(overallTag, element); //  Moving whole details tag to original place

    tooltipTextTag.style.zIndex = (($(overallTag).closest("details").length > 0) ? "199" : "98");
    if (!withoutDetails) {
        $(detailsTag).details(); //detailsTag.open =detailsTag.open; //details_shim(detailsTag);
        ElementTag.focus()
    }


    return overallTag;
}

/*

// Strip Diacritics from text
// http://stackoverflow.com/questions/990904/javascript-remove-accents-in-strings
// String containing replacement characters for stripping accents 
var stripstring =
    'AAAAAAACEEEEIIII' +
    'DNOOOOO.OUUUUY..' +
    'aaaaaaaceeeeiiii' +
    'dnooooo.ouuuuy.y' +
    'AaAaAaCcCcCcCcDd' +
    'DdEeEeEeEeEeGgGg' +
    'GgGgHhHhIiIiIiIi' +
    'IiIiJjKkkLlLlLlL' +
    'lJlNnNnNnnNnOoOo' +
    'OoOoRrRrRrSsSsSs' +
    'SsTtTtTtUuUuUuUu' +
    'UuUuWwYyYZzZzZz.';

function stripDiacritics(str, optionSelected) {

    if (optionSelected == false) {
        return str;
    }

    var answer = '';
    for (var i = 0; i < str.length; i++) {
        var ch = str[i];
        var chindex = ch.charCodeAt(0) - 192; // Index of character code in the strip string
        if (chindex >= 0 && chindex < stripstring.length) {
            // Character is within our table, so we can strip the accent...
            var outch = stripstring.charAt(chindex);
            // ...unless it was shown as a '.'
            if (outch != '.') ch = outch;
        }
        answer += ch;
    }
    return answer;
}

// http://stackoverflow.com/questions/3446170/escape-string-for-use-in-javascript-regex
// NOTE: if this script is located in html layout template, must escape every \\ in the export code because of the JabRef Export...
//return str.replace(/[-\\[\\]\\/\\{\\}\\(\\)\\*\\+\\?\\.\\\\\\^\\$\\|]/g, "\\\\$&");

function escapeRegExp(str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
}

// getElementsByClassName polyfill
//http://stackoverflow.com/questions/20616832/jquery-getelementsbyclassname-equivalent
(function() {
    if (document.getElementsByClassName)
        return;
    if (!window.Element)
        throw ("Your browser neither knows getElementsByClassName nor Element. Can't help and polyfill getElementsByClassName");

    function gEBCN(className) {
        //alert("gebcn");
        var all = this.getElementsByTagName("*"),

            rex = new RegExp("(?:\\s|^)" + className + "(?:\\s|$)"),
            out = [],
            element, i;
        for (i = all.length; i--;) {
            element = all[i];
            if (element.className.match(rex))
                out.unshift(element);
        }
        return out;
    }

    var el = window.Element.prototype;
    var doc = document.constructor.prototype;
    el.getElementsByClassName = doc.getElementsByClassName = gEBCN;
}());
*/
function stripHTML(HTMLString) {
    //alert (HTMLString + "\n\nstripped:\n\n"+HTMLString.replace(/<(?:.|\n)*?>/gm, '\n'));
    //return HTMLString.replace(/<(?:.|\n)*?>/gm, '');
    return HTMLString.replace(/<.*?>/gm, '');


}


    var _months = { 
        "jan" : "01", 
        "feb" : "02",
        "mar" : "03",
        "apr" : "04",
        "may" : "05",
        "jun" : "06",
        "jul" : "07",
        "aug" : "08",
        "sep" : "09",
        "oct" : "10",
        "nov" : "11",
        "dec" : "12"
    };
    
function propName(prop, value){
//only works properly for unique values! (otherwise possibly random output)
   for(var i in prop) {
       if (prop[i] == value){
            return i;
       }
   }
   return false;
}



function brify(text) {
    return text.replace(/(\r\n|\n|\r)/gm, "<br \/>" + liBr);
    
}


/*function deBrify(text) {
    return text.replace(/(<br>)|(<p>)/g, "\n");
}
*/


/* http://stackoverflow.com/questions/1500260/detect-urls-in-text-with-javascript 
 * */



function legalisestring(mystring) {
    return mystring.replace(/\W+/g, "_")
}

function lnkEx(url, text) {
	if (!text) text=url;
    return "<a href='" + url + "' target='_blank' class=ex rel=external title='" + url + " - open in new window/tab'>" + text + "<\/a>";
}

/*
function urlify(text) {

    if (text.match(/<a .*?href.*<\/a>/) || (typeof text != "string")) {
        return text
    } else

    {
        return text.replace(
                /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig,
                function(url) {
                    return lnkEx(url, url);
                })
            // or alternatively
            // return text.replace(urlRegex, '<a href="$1">$1<\/a>')

    }
}
*/




//// http://stackoverflow.com/questions/11863847/regex-to-match-urls-but-not-urls-in-hyperlinks
//function urlifyNode(node) {

//{
//var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/i;
//var nodes=node.childNodes;
//for (var i=0, m=nodes.length; i<m; i++){
//var n=nodes[i];
//if (n.nodeType==n.TEXT_NODE) {
//var g=n.textContent.match(exp);
//while(g) {
//var idx=n.textContent.indexOf(g[0]);
//var pre=n.textContent.substring(0,idx);
//var t=document.createTextNode(pre);
//var a=document.createElement("a");
//a.href=g[0];
//a.innerText=g[0];
//n.textContent = n.textContent.substring(idx+g[0].length);
//n.parentElement.insertBefore(t,n);
//n.parentElement.insertBefore(a,n);
//g=n.textContent.match(exp);
//}
//}
//else {
//urlifyNode(n);
//}
//}
//}
//}


//http://stackoverflow.com/questions/263965/how-can-i-convert-a-string-to-boolean-in-javascript 
function stringToBoolean(string) {
    if (string != undefined) {
        string = string.toString();
        switch (string.toLowerCase()) {
            case "true":
            case "yes":
            case "1":
                return true;
            case "undefined":
            case "false":
            case "no":
            case "":
            case "0":
            case null:
                return false;
            default:
                return true;
        }
    } else return null;
}

// http://www.quirksmode.org/js/cookies.html 
function createCookie(name, value, days) {
    if (!days) days = "7";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        var expires = "; expires=" + date.toGMTString();
    } else var expires = "";
    document.cookie = name + "=" + value + expires + "; path=/";
    //window.alert(name+"="+value+expires);
}

function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0) {
            //window.alert("cookie gelesen: " + name + "="+c.substring(nameEQ.length,c.length));
            return c.substring(nameEQ.length, c.length);
        }
    }
    return null;
}

function clearCookie(name, domain, path){
    var domain = domain || document.domain;
    var path = path || "/";
    var date=new Date();
    date.setTime(date.getTime()-1);
    document.cookie = name + "=; expires=" + date.toGMTString() + "; domain=" + domain + "; path=" + path;
};

function lnkIntDb(CiteString, optParentInfo,forceOnPlainString) {
    //take String, find place with latex cite commands, 
    // read out what is between curley braces, 
    // replace every comma-separated part with
    /*
	 "&#32;<wbr><a class=in href=\"javascript:g2A(\'" + AllCitedWorksArray[i] + "\'" + optParentInfo + ")\" onFocus=\"bTT(this)\" onmouseover=\"bTT(this)\">" + AllCitedWorksArray[i] + "<\/a>";
	 */





    

    //transport optional variable
    var optCode = (optParentInfo) ? (",'" + optParentInfo + "'"): "";

    var wbr = "<span class=breakingspace><\/span>";
    
	/*"<span class='counter nobr'>"*/ 
	var htmlfix = [
					wbr + "<a class='in nobr' href=\"#", 
					"\" onclick=\"g2A(\'",
					"\'" + optCode + ");return false\" onmouseover=\"bTT(this)\" onfocus=\"bTT(this)\">",
					"<\/a>"
					];
	/*"<\/span>"*/
	
						function core_SplitAndFixCitations (coreString) {
							var citations = coreString.split(","); 
							for (var i = 0; i < citations.length; i++) {
								
									citations[i] = htmlfix.join (citations[i]);
							}
							return citations;
						}
    
    if (forceOnPlainString ) 
    {
		return core_SplitAndFixCitations(CiteString).join(",")+wbr;
		}
	
	var MyRegEx = /\\cite(?:\[.*?\])?\{(.+?)\}/gm;
	
	var latexfix=["<code class='latex nobr' title=\"LaTex markup code for citation\">","<\/code>"];
    var availCitations = [];
    var Output = "";
    var normalstart = 0;
    
	
	
    while ((myArray = MyRegEx.exec(CiteString)) !== null) {
        //myArray[0]: outer hit string
        //myArray.index: start index of outer hit
        //MyRegEx.lastIndex: end index of outer hit+1
        //myArray[1]: inner hit string

		//whatever is before this hit:
        Output+= CiteString.substr(normalstart, myArray.index - normalstart); 
        
        //Output+="<span class=countstart><\/span>"; //Listing CSS
        //outer hit until inner hit:
        Output+= latexfix.join (
        myArray[0].substr(0, myArray[0].indexOf(myArray[1])) 
        );  

		//inner hit (core): search for multiple keys and reconstruct
		availCitations=core_SplitAndFixCitations(myArray[1])
		
        

        Output+=   availCitations.join(
				latexfix.join(",") 
				) + wbr+latexfix.join("}");
				
		//Output+="<\/span>"; //Listing CSS
        
        normalstart = MyRegEx.lastIndex;
    }
    
		//whatever is AFTER LAST HIT (outside loop):
        Output+= CiteString.substr(normalstart, CiteString.length-normalstart); 
    
    
    return ((Output) ? Output  : CiteString);

}

function latexDeco (code){
var latexfix=["<code class=latex title=\"LaTex markup code\">","<\/code>"];

	return code.replace(/(\\[a-z]+(?:\[.*?\])?\{)(.*?)(\})/gm ,
        latexfix.join("$1")+ latexfix.join("$2") + latexfix.join("$3"))
	}





function getLineSeparator() {
  var textarea = document.createElement("textarea");
  textarea.value = "\n"; 
  return textarea.value||"\n";
}
var liBr = getLineSeparator();















						function eliminateDuplicates(arr) {
								  var i,
									  len=arr.length,
									  out=[],
									  obj={};

								  for (i=0;i<len;i++) {
									obj[arr[i]]=0;
								  }
								  for (i in obj) {
									out.push(i);
								  }
								  return out;
								}

/*
function saferArrayOfStrings (MyInput){
var MyOutput
(typeof MyInput === 'string' || MyInput instanceof String) ? 
MyOutput.push(MyInput) : 
MyOutPut=MyInput;
}
*/
