//TODO: periodical und article korrigieren falls kein volume, nur number oder issue, oder gar nichts. oppolzer OK?
//TODO: Wartung der Liste
//TODO: z.B. Dittrich A (1909): "Kuglers Bestreitung des Alters der babylonischen Astronomie veranlaßte mich zu der Untersuchung, wie man wohl auf die Voraussage der Finsternisse gekommen ist. [..]" In: Das Alter der babylonischen Astronomie. By Jeremias, Alfred Karl Gabriel. (Im Kampfe um den Alten Orient: Wehr- und Streitschriften nr. 3.) Leipzig: Hinrichs’sche Buchhandlung, 67. URL: https://archive.org/stream/dasalterderbaby00jere#page/66/mode/2up (visited on 11 Sep 2013).  --> Editor (hier Jeremias) sollte wie author (hier Dittrich) geschöpft werden, also nicht als längerer String




var documentCreationDate = document.getElementById("htmlCreationDate").textContent;
var escapeConflictPrefix = "bibmas" + documentCreationDate.replace("-", "").substr(2, 4) + "_";
var windowPrefix=escapeConflictPrefix+"window_";
var clientCookies={curSel: escapeConflictPrefix+"selectedRecords"}
var bibmasDomTable,bibmasDataTable,bibmasdataTable;


/* developmental info */

var generalInfos = 
{
"Version history": [
    undefined, {
        h34d: "<del datetime='2014-08-31'>v.0.1.1 (experimental)<\/del>",
        l1st: ["unpublished first version, no previous release"]
    }, {
        h34d: "<del datetime='2014-09-17'><ins datetime='2014-08-31'>v.0.2 (experimental)<\/ins><\/del>",
        l1st: [
            "removed Schenk search engine, Zielke Pager and Bach tableSorter, changed to dataTables (see credits).", "thereby removed search options (shall return in other form)"
        ]
    }, {
        h34d: "<del datetime='2014-09-29'><ins datetime='2014-09-17'>v.0.2a (experimental)<\/ins><\/del>",
        l1st: [
            "changed title", "minor improvements of keyboard accessibility (details tag)", "minor corrections of database"
        ]
    }, {
        h34d: "<del datetime='2014-12-04'><ins datetime='2014-09-29'>v.0.2b (nightly)<\/ins><\/del>",
        l1st: [
            "minor corrections/enhancements of database",
            "minor enhancements in dialog box (sizing and positioning)",
            "added raw text and filesave function for dialog box ",
            "improved recognizing of internal reflinks",
            "fixed some shortcomings of the title set dialog (which is now dynamically generated)",
            "added field and type tooltips from "+ lnkIntDb("lehman2013thebiblate",windowPrefix+"version_history",true),
            "added keyboard accessibility to custom tooltip behaviour",
            "improved sortability of author and title via putting biblatex sorttitle/sortname field contents into html5 cdata-attributes of table cells (thereby compensating for diacritics, regognizing numbers, and also removing the/a(n)/un(e)/le/la/die/der/das/über etc from title start.)",
            "for speeding up loading, made most external JavaScript execute when the page has finished parsing",
            "fixed some minor bugs with Konqueror and Safari"
        ]

    }, {
        h34d: "<del datetime='2015-01-17'><ins datetime='2014-12-11'>v.0.2c (nightly)<\/ins><\/del>",
        l1st: [
            "minor corrections/enhancements of database (e.g. changed some type designations etc)",
            "minor enhancements in dialog box (re-sizing)",
            "improved HTML 5 validity",
            "improved cross-browser compatibility",
            "fixed a bug with column search which occured after column re-arrangement",
            "made some JS more unobstrusive",
            "started including keywords: importing tablet numbers from Walker´s and van Gent´s database, startet collecting additional information from PDF files",
            "made it possible to display title set even with javascript disabled (css:target selector only)",
            "introducing multiple row select and export"
        ]
    }, { 
		h34d: "<ins datetime='2015-01-17'>v.0.2d (nightly)<\/ins>",
		l1st: [
			"continuous minor corrections and enhancements in database",
			"minor changes of unicode symbols",
			"fixed a bug in title set/biblatex function concerning display of field values with automatic detection of internal links, which had been hiding text of single field values after the last internal link found (i.e. if there was at least one finding and if there was text after it)",
			"minor correction in html export templates (including specific handling of organization fields in manuals and online ressources)",
			"better error handling"
		]
	}, { 
		h34d: "<ins datetime='2015-11-09'>v.0.3<\/ins>",
		l1st: [
			"expanding database with hundreds of further records, both with newer resp. up-to-date ones (Stephenson, Brack-Bernsen, Cooley, Gautschy, Fincke, Ben-Dov, Koch J, Steele, Ossendrijver, Rochberg, Xu, Horowitz, Hunger, Mitsuma, Jong), and with older ones (drawn from Rob vGent and others)",
			"expanding and rebuilding internal links in database according to biblatex standards, i.e. making use of proper fields fields: 'related', 'relatedstring' etc; instead of arbitrary 'reviewof' field, reconceptualizing 'x-ref' / 'crossref' fields",
			"extended abstract, keywords, DOI, URL data",
			"extended functionality for add. pub. inf.",
			"uniformed headers of reviews for easy sorting",
			"expanded usage of sorttitle, sortname, sortkey",
			"filtering out some marginally relevant records",
			
			"various minor corrections and enhancements in database (more logical usage of addendum/note fields, corrected bibliographical data in singular cases)",
		]
	}, { 
		h34d: "<ins datetime='2015-11-13'>v.0.3.1<\/ins>",
		l1st: [
			"minor corrections in database",
			"added reduced HTML and PDF versions",
		]
	}, { 
		h34d: "<ins datetime='2016-01-18'>v.0.3.2<\/ins>",
		l1st: [
			"some additions and corrections in database",
			"bugfixes, e.g. in column-specific search field title",
		]
	},
       { 
		h34d: "<ins datetime='2017-06-23'>v.0.4<\/ins>",
		l1st: [
			"updated and refreshed database",
			"bugfixes, i.e. in handling details with newer Firefox browser (since FF49)",
		]
	},
       { 
		h34d: "<ins datetime='2017-09-23'>v.0.5<\/ins>",
		l1st: [
			"added function to produce shorter, more compact bibliographic lists",
			"updated and refreshed database",			
		]
	}, 
       { 
		h34d: "<ins datetime='2018-06'>v.0.6<\/ins>",
		l1st: [
			
			"updated and refreshed database",			
		]
	}

	
	
],

"Credits": [
    'Credits:', {
        h34d: "Main <strong>contents<\/strong> of this database are built upon:",
        l1st: [
            "bibliography references from <a href='#walker2013bibliograp' onclick='g2A(\"walker2013bibliograp\",\"credits\");return false' onfocus='bTT(this)' onmouseover='bTT(this)' class=in>Christopher Walker<\/a> (<a  href='#walker1993bibliograp' onclick='g2A(\"walker1993bibliograp\",\"credits\");return false' onfocus='bTT(this)'  onmouseover='bTT(this)' class=in>1993<\/a>, <a class=in href='#walker2013bibliograp' onclick='g2A(\"walker2013bibliograp\",\"credits\");return false' onfocus='bTT(this)'  onmouseover='bTT(this)'>2013<\/a>)",

            "bibliography references from <a class=in href='#gent2004bibliograp' onclick='g2A(\"gent2004bibliograp\",\"credits\");return false' onfocus='bTT(this)' onmouseover='bTT(this)'>Robert van Gent (2004)<\/a>.",

            "lists, notes and collections of works on Babylonian mathematical astronomy by " + lnkEx("http://amor.cms.hu-berlin.de/~ossendrm/", "Mathieu Ossendrijver") + " (<time>2013/2014<\/time>)"
        ]
    }, {
        h34d: "The <strong>form<\/strong> of the database per se is constructed and maintained",
		l1st: ["using the software " + lnkEx("http://jabref.sourceforge.net", "JabRef") + ", a very usefull opensource tool for managing BibLatex databases (see "+ lnkIntDb ("lehman2013thebiblate",windowPrefix+"Credits",true) + "). The HTML format is created thanks to JabRef HTML export features (see "+lnkEx("http://jabref.sourceforge.net/help/de/CustomExports.php","german help page") + " or " + lnkEx("http://jabref.sourceforge.net/help/CustomExports.php","english help page")+")"],
    }, {
				
		h34d: "Main portions of code for this <strong>html document<\/strong> gratefully originate from following sources:",
        l1st: [

            "JS functions for sorting, searching and paging: " + lnkEx("http://www.datatables.net/", "JQuery DataTables plug-in <ins datetime='2015-06-28'>v1.10.7 <\/ins> by Allan Jardine") + " (Copyright (C) 2008-2015, SpryMedia Ltd.) " + lnkEx("http://www.datatables.net/license_mit", "MIT licensed") + ". Thanks!",

            "HTML table " //<del datetime='2014-08-31'>with inforow toggle and internal search engine<\/del>
            +"based on templates from " + lnkEx("http://www.markschenk.com/tools/jabref/", "JabRef HTML Export templates by Mark Schenk") + ", covered by " + lnkEx("http://creativecommons.org/licenses/by/3.0/", "Creative Commons Attribution License") + ".",

            //"<del datetime='2014-08-31'>JS functions for sorting: " + lnkEx("http://tablesorter.com/docs/", "JQery tablesorter v.2.0.5 by Christian Bach") + "<\/del>",

            //"<del datetime='2014-08-31'>JS functions for pagination: " + lnkEx("http://neoalchemy.org/tablePagination.html", "JQery tablePagination by Ryan &quot;Neoalchimy&quot; Zielke 2009") + "<\/del>",

            "CSS tooltips based on " + "demonstrative work by Olivia Hoback, formerly available on www.the-perfect-life.org", //lnkEx("http://www.the-perfect-life.org/html-5-css-3-php-wordpress-jquery-javascript-photoshop-illustrator-tutorial/source-code/tooltip-styling/style.css", "demonstrative work by Olivia Hoback"),

            "HTML5 Details and summary polyfill for non-supportative Firefox, IE etc: " + lnkEx("https://mathiasbynens.be/notes/html5-details-jquery", "Bulletproof HTML5 &lt;details&gt; fallback using jQuery by Mathias Bynens"),

            "JS and CSS for moveable and resizeable divs come from " + "byrei DynDiv 0.5"
            //lnkEx("http://dyndiv.markusbordihn.de", "byrei DynDiv 0.5") 
            + " copyright (c) 2008 by " + lnkEx("http://markusbordihn.de", "Markus Bordihn") + ". Dual licensed under the " + lnkEx("http://opensource.org/licenses/MIT", "MIT") + " and " + lnkEx("http://www.gnu.org/copyleft/gpl.html", "GPL") + " licenses.",

            "CSS icons taken from " + lnkEx("http://one-div.com/", "one-div.com") + " by Vincent Durand." //+ lnkEx("http://vincentdurand.fr/", "Vincent Durand") + "<del>, and " + lnkEx("http://nicolasgallagher.com/pure-css-gui-icons/demo/#non", "nicolasgallagher.com/pure-css-gui-icons") + " by " + lnkEx("http://nicolasgallagher.com/", "Nicolas Gallagher") + "<\/del>."

        ]
    }
],

"Known issues": [
    "Known issues and features for future releases", {
		
        h34d: "<ins datetime='2017-06-16'>The following list just represents a brainstorming from an earlier stage of development, rather to be saved for documentary purposes, but not to be misunderstood as actual announcement.<\/ins><br>At current stage, there are still some limitations to overcome. Aside from maintenance and continuously feeding the database, new features still may be expanded:",
        l1st: [
			"<del datetime='2015-11-09'><ins datetime='2014-10-09'>correcting default sorting key so that authors / editors of same surname are separated by their first names too: just started implementing <code>sortkey<\/code> field, yet to be continued and improved.<\/ins><\/del>",
            "<ins datetime='2014-10-09'>adding more keywords about tablet museum numbers and identifications of relevant texts<\/ins>",
            "semantic <em>keywords<\/em> (e.g. star and planet names, time periods, cuneiform tablet identifiers etc.) should be added to the records to simplify sorting out relevant records for different given contexts of researches",
            "<del datetime='2014-08-31'>searching <em>in<\/em> or sorting <em>while<\/em> using <strong>pager view<\/strong> yields unwanted results (e.g. search results are not bundled)<\/del>",
            "<del datetime='2014-09-24'>table sorting cannot deal with diacritics<\/del>",
            "sorting options could be elaborated",
            "keep in mind if performance and loading time still could be optimized",
            "reduce data redundancies (e.g. proceedings - titleaddon and eventdata)",
            "optimize semantic html structure",
            "ad semantics: implement "+lnkEx("http://microformats.org/wiki/hcard","HCard") + " infos about authors and institutions and html5 microdata ("+ lnkEx("http://schema.org/CreativeWork","schema.org/CreativeWork") + ", e.g. like "+lnkEx("http://www.kanzaki.com/works/2013/misc/0518-citation.html#references","shown at kanzaki.com")+" and at " + lnkEx("http://linter.structured-data.org/examples/schema.org/PublicationVolume/","linter.structured-data.org")+") for other citation lements; see also " + lnkEx("http://microformats.org/wiki/citation","microformats.org/wiki/citation")+".",
			"make it Zotero friendly, e.g. implement "+ lnkEx("http://ocoins.info/#id3205609414","COINS"),
            "handling reprints and original prints",
            "optimizing internal x-refs (eg more bidirectionality?)",
            "add more information about relations using the related fields -related, relatedoptions, relatedstring, relatedtype- (as in "+ lnkIntDb("\\cite[27]{lehman2013thebiblate}",windowPrefix+"known_issues") + ") rather than using x-ref and diverse note fields",
            "include shortauthor, shorteditor, nameaddon, altauthor, alteditor, affiliation",
            "<del datetime='2014-08-31'>move, add, remove table columns, drag &amp; drop?<\/del>",
            "&quot;jump to next&quot; function similar to search filter function",
            "toggle search using regular expressions",
            "remove superfluous javascript in some references",
            "plus more (tell me your opinion!)"
        ]
    }
]
}


	

/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---              startup functions            --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */

var ArrayOfBibKeys = [];


function when_parsed() {

showInfoBar("Finishing header...");
	

	var versionHistory=generalInfos["Version history"];
	versionHistory[0] = "Revision history -- changes between the " + (versionHistory.length - 1) + " versions:";	
		 //finish Header
			document.getElementById("versioninfofield").innerHTML = 
					"<strong><span title='- " + stripHTML(versionHistory[versionHistory.length - 1].l1st.join(liBr +"- ")) + 
					liBr +liBr +"(see version history for details)'>" + versionHistory[versionHistory.length - 1].h34d + "<\/span><\/strong>&#32;";
			
				
				var deftable=function (y)  
										{
											var x=generalInfos[y].length;
											//http://www.sitepoint.com/making-css-count-backwards/
											var str="<dl class=headedlist><dt>"+generalInfos[y][0]+"<\/dt><dd><dl class=\"smallindent " + 
											(y=="Version history" ? 
												"count-backwards\" style=\"counter-reset:start-from "+x : 
												"count-forward" )
											+ "\">" + liBr +liBr;
											for (var i = x; i > 1; i--) {
																str += "\t<dt>" + generalInfos[y][i-1].h34d + "<\/dt>"+liBr+liBr +"<dd><ul><li>"+generalInfos[y][i - 1].l1st.join(liBr+"<li>") + "<\/dd>"+liBr+liBr
																}
											return( encodeURIComponent(str+"<\/dl><\/dd><\/dl>"));
										}
				
				
										
			var sib=document.getElementById("downloadoptions");
			var x,y;
			
			for (var whichinfo in generalInfos)
			{
			
				x = document.createElement("li");
				y = document.createElement("a");
				y.href = "#z";
				y.textContent = whichinfo + "..";
				
				y.setAttribute("onclick","{popUp(\""+ whichinfo+"\",decodeURIComponent(\""+deftable (whichinfo)+"\"),false,false,\""+whichinfo+"\");return false}");
				x.appendChild(y);
				sib.parentNode.insertBefore(x, sib);
			}
			
			
			
	$('details').details();		
			

    /* Initializing further Scripts */

	showInfoBar("Enhancing on original HTML DOM table ...");
    

	bibmasDomTable=document.getElementById("bibmasmaintable");
	
	var header=bibmasDomTable.getElementsByTagName('thead')[0].rows[0],
		typeColInd= header.getElementsByClassName('typecolumn')[0].cellIndex, 
		allRows = bibmasDomTable.getElementsByTagName('tbody')[0].getElementsByTagName('tr'), 
		allrowslength=allRows.length,	
		temp1,temp2;
	

//https://dev.opera.com/articles/efficient-javascript/#minimumreflow


/*	function cellAppend(myrow,celltype) {
		var mycell=document.createElement(celltype);
		myrow.appendChild(mycell);
		return mycell;
		
		}
	
	var x=cellAppend(header,"th");x.nodeValue="*";
	x.className="selectCol";
	x = cellAppend(bibmasDomTable.getElementsByTagName('tfoot')[0].rows[0], "td");
	x.nodeValue="";
	x.className="selectCol nothing";
*/		
	
		
	//for (var i in allRows) {

	for (var i=0; i<allrowslength;i++) {
		temp1= allRows[i].cells[typeColInd].getElementsByTagName("abbr")[0];//.firstChild;
		temp2= temp1.firstChild.nodeValue;	
    
		temp1.title=temp2+": " + biblatexTypes[temp2];
		
/*		temp1=cellAppend(collectTemp[i],"td");
        *//*temp2 = document.createElement("input");
        temp2.type="checkbox";
        
        //temp1.setAttribute("data-order","0");
        temp1.className="selectCol";
        temp2.className="selectColCheckBox";
        
        
        temp2.setAttribute("onchange",	"selectRow(this.parentNode.parentNode.id,undefined,true,true,false);this.focus();");
        
        temp1.setAttribute("onclick",	"if (!$(document.activeElement).hasClass('selectColCheckBox')) $(this.firstChild).trigger('change')");
        //temp1.setAttribute("onkeydown",	"if (event.keyCode==13) $(this.firstChild).trigger('change')");
        temp1.appendChild(temp2);
        *//*
        temp1.innerHTML='<td onclick="if (!$(document.activeElement).hasClass(\'selectColCheckBox\')) $(this.firstChild).trigger(\'change\')" class="selectCol"><input onchange="selectRow(this.parentNode.parentNode.id,undefined,true,true,false);this.focus();" class="selectColCheckBox" type="checkbox"><\/td>';
*/        
        
	}



//save current selection at closure
	$(window).unload(new Function("saveCookies()"));


//restore selection from last session
	var x=readCookie(clientCookies.curSel);
	if (x) {
	var temparray=x.split(",");
	
	$(temparray).each(function (i){
		selectRow(temparray[i],true,false,true);
		});
	//invalidateTable(true);
	}



//implement selection ability
	$('#bibmasmaintable tbody').on('mousedown', 'tr', function(evt) {
											try {
												if ($(document.activeElement.parentNode) && ($(document.activeElement.parentNode).hasClass('s3l')))return; 
												if (evt.ctrlKey)
												 {
													 
        												selectRow(this.id,undefined,true)

													evt.stopPropagation();			evt.preventDefault();
													
												}
												}
												catch(err){/*
												showInfoBar(err)
												*/
												}
												}
											)
								.on("keyup","tr",function(e) {
									try{
									if (e.ctrlKey||$(document.activeElement.parentNode).hasClass('s3l')) {
									switch (e.keyCode)
									{
										case 13: //enter
										var eTrigger = jQuery.Event("mousedown");
										eTrigger.ctrlKey = true;
										$(this).trigger(eTrigger);
										e.stopPropagation();			e.preventDefault();
										break;
										
										case 40: //down arr
										$(this).next("tr").find(".s3l")[0].firstChild.focus();
										break;
										
										case 38: //up
										$(this).prev("tr").find(".s3l")[0].firstChild.focus();
										
										break;
									}
									}
									}
									catch(err){}
								});



	

  
//	alert("initalising datatables");
    showInfoBar("Initializing dataTables PlugIn ...");

//var d4t4c3ll1nd3x=document.getElementById("bibmasmaintable").getElementsByTagName("thead")[0].getElementsByClassName('d4t4')[0].cellIndex;

bibmasDataTable=    $(bibmasDomTable).DataTable({
        autoWidth: false,
        iDisplayLength: 25,
        bAutoWidth: false,
        aLengthMenu: [5, 10, 25, 50, 75, 100, 125, 150, 175, 200, 250, 500, 750, 1000, 1250, 1500, 1750, 2000, 2500, 3000, 3500, 4000],
        aaSorting: [
            [sortkeycellindex, 'asc']
        ],
        bDeferRender: true,
        deferRender:    true,
        
        orderClasses: false,
       dom: 'C<"toolbar2">lRf<"toolbar1">'+
			'i<"toolbar3">rp' +
            't' +
            'ip',
            
/// C - colvis            
///  l - Length changing
///  f - Filtering input
///  t - The Table!
///  i - Information
///  p - Pagination
///  r - pRocessing
///  < and > - div elements
///  <"#id" and > - div with an id
        "colVis": {
            "label": function ( index, title, th ) {
                return (index+1) +'. '+ title;
				}
            },
        processing: true,
        //"sScrollY": "400px", //could help to speed things up, but at first glance  conflicts with other options and looks a bit messy
        //scrollY:        400,
        
        //scrollCollapse: true,
        
        columnDefs: [
     	{
			 sClass: "s3l", targets: ["s3l"]
		},
		
		
		{
			 sClass: "authorcolumn", targets: ["authorcolumn"]
		},
		{
			 sClass: "editorcolumn", targets: ["editorcolumn"]
		},


{
			 sClass: "titlecolumn", targets: ["titlecolumn"]
		},
		
		{
			 sClass: "yearcolumn", targets: ["yearcolumn"]
		},
				
	
		
		{
			 sClass: "parentcolumn", targets: ["parentcolumn"]
		},
		{
			 sClass: "typecolumn", targets: ["typecolumn"]
		},

		{
			 sClass: "keywordscolumn", targets: ["keywordscolumn"]
		},
		{
			 sClass: "entrykeycolumn", targets: ["entrykeycolumn"]
		},
		{
			 sClass: "sortkeycolumn", targets: ["sortkeycolumn"]
		},
		
		{
			 sClass: "d4t4", targets: ["d4t4"]
		},
		
		
	   
		{ 
			 visible: false, "targets": ["DTdefaulthidden", "d4t4"]
		},
		
	
		
		
/*			{ 
				orderDataType: "mystring", //http://www.datatables.net/plug-ins/sorting/#how_to_type ?
				targets: "editorcolumn"
			},*/
			/*{ 
				orderDataType: "anti-the", 
				targets: ["parentcolumn","titlecolumn"]
			},*/
        {
            type: 'anti-the',             //rather dont touch before you understand it 
            targets: "urlcolumn"
        }, {
            type: "html",
            targets: "_all"
        } /*, {
			type: "mystring",
			targets: "_all"
		}*/ ],
        sPaginationType: "input",
        
    });
    /*,
            { type: 'natural', targets: "_all" }*/


//alert("adapting DT");
    showInfoBar("Adapting dataTables PlugIn ...");
    
    
     
///$('#bibmasmaintable tbody').on( 'click', 'tr', function () {    alert( 'Row index: '+bibmasDataTable.row( this ).index() );} );
    
    
      //var table = $('#bibmasmaintable').DataTable();     $.fn.dataTable.KeyTable( table );
/*bibmasdataTable = $(bibmasDataTable).dataTable({
	columnDefs: [
        { "visible": false, "targets": sortkeycellindex }
        ]
	});
*/
//bibmasDataTable.column(sortkeycellindex).visible(false);
//bibmasDataTable.column(entrykeycellindex).visible(false);


  var mybutton,reloadCarrier = document.createElement("div");
    mybutton = document.createElement("button");
    mybutton.setAttribute("onclick", "invalidateTable(true)");
    mybutton.setAttribute("type", "button");
    mybutton.textContent = "\u21BB Redraw datatable";
    mybutton.title="Invalidate the data held in DataTables, and re-draw the table";
    reloadCarrier.appendChild(mybutton);
    
    
	mybutton = document.createElement("button");
    mybutton.setAttribute("onclick", "reloadTable()");
    mybutton.setAttribute("type", "button");
    mybutton.textContent = "\u2718 Reset datatable";
    mybutton.title="Return to factory settings.";
	reloadCarrier.appendChild(mybutton);
	
    
    var CSbutton = document.createElement("button");
    CSbutton.className = "button";
    CSbutton.setAttribute("type", "button");
    CSbutton.setAttribute("onclick", "clearSearch()");
    CSbutton.textContent = "\u2717 Clear search";
    CSbutton.setAttribute("title", "Undo all search previously applied filters.");


	var selection=document.createElement("div");
	
	var label=document.createElement("label"), labelpart;
	label.setAttribute("id","bibmasmaintable_selectioncounter");


	
	labelpart=document.createElement("span");
	labelpart.textContent="\u2611 ";
	label.appendChild(labelpart);
	
	labelpart=document.createElement("span");
	labelpart.id="table_selected_counter";
	label.appendChild(labelpart);
	
	labelpart=document.createElement("span");
	
	labelpart.id="table_selected_text";
	
	label.appendChild(labelpart);
	selection.appendChild(label);
	
	/**/
	mybutton = document.createElement("button");
	mybutton.className="button";
	mybutton.setAttribute("type","button");
	mybutton.setAttribute("onclick","exportSelected(1001)");
	mybutton.setAttribute("id", "bibmasmaintable_selection_shortcite");
	mybutton.textContent= 	"\u2750 Compact list..";
	selection.appendChild(mybutton);
    /**/
	
	
	mybutton = document.createElement("button");
	mybutton.className="button";
	mybutton.setAttribute("type","button");
	mybutton.setAttribute("onclick","exportSelected(1)");
	mybutton.setAttribute("id", "bibmasmaintable_selection_titleset");
	mybutton.textContent= 	"\u2750 Title sets..";
	selection.appendChild(mybutton);
	
	mybutton = document.createElement("button");
	mybutton.className="button";
	mybutton.setAttribute("type","button");
	mybutton.setAttribute("onclick","exportSelected(0)");
	mybutton.setAttribute("id", "bibmasmaintable_selection_biblatex");
	mybutton.textContent="\u2750 BibLaTex..";
	selection.appendChild(mybutton);
	
	
	
	
	mybutton=document.createElement("button");
	mybutton.className="button";
	mybutton.setAttribute("type","button");
	mybutton.setAttribute("onclick","if(confirm('Confirm this procedure to clear your selection.')){"+
								"showInfoBar('Removing selection attributes');"+
								"$(bibmasDataTable.rows('.selected').nodes()).each("+
								"function(){selectRow($(this).attr('id'),false,false)});"+
								"updateSelected();"+
								"showInfoBar(false)}");
	mybutton.textContent="\u2717 Unselect all";
	
	selection.appendChild(mybutton);
	
$("div.dataTables_filter").append(CSbutton)
//    $("div.toolbar1").html(CScarrier.innerHTML)
    $("div.toolbar2").html(reloadCarrier.innerHTML);
    $("div.toolbar3").html(selection.innerHTML);
    
    $("div.toolbar3").attr("id","bibmasmaintable_selectiontoolbar");
    updateSelected();
    addColumnSearch();






var greetings='<strong>Database now ready to use.<\/strong> Note the&ensp;<a href="#keyfeatures" class=in>basic usage instructions concerning key features<\/a>&ensp;such as sorting, searching etc.';

greetings= showInfoBar(greetings, 2);
    if (location.hash) {
        x = location.hash.substr(1, location.hash.length - 1);

        try {
            (g2A(x, "onLoading"))
        } catch (err) {
            console.log(x + ": "+ err)
        };
    }
document.body.setAttribute("onhashchange","g2A(location.hash,'onLoading')");

showDb();
    setTimeout("showInfoBar(false,2,'" + greetings + "')", 7000)



}





/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---              bibkeysArray                  --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */





function assignArr2Dl(articleid) {
//setActiveRow(articleid);
    // quit if this function has already been called
//    alert(articleid);
    if (safeRead(ArrayOfBibKeys,articleid)) {
//                console.log("assignArr2Dl: quitting for " + articleid + " coz already done ("+ ArrayOfBibKeys[articleid] +")");
        return;
    }
    //var bibmasDataTable = $('#bibmasmaintable').DataTable()
         try {   
    var d4t4c3ll = bibmasDataTable.cell("#" + articleid, ".d4t4").node();
    //console.log(d4t4c3ll)

    var dtDl = d4t4c3ll.getElementsByTagName("dl")[0];
 
    
    if (!safeRead(ArrayOfBibKeys, articleid)) ArrayOfBibKeys[articleid] = new Object;
    //var typ = dtDl.getElementsByClassName("typ")[0].textContent;
    

        var dtTags = dtDl.getElementsByTagName("dt");
        var ddTags = dtDl.getElementsByTagName("dd");
    } catch (err) {
        var error = 'error in function assignArr2Dl(' + articleid + '):' + err;
        //showInfoBar(error, 1);
        console.log(error);
        return null
    }
    //console.log(dtTags);
    //var valCode;

    var myfield;

    for (var i = 0; i < dtTags.length; i++) {
        myfield = dtTags[i].firstChild.nodeValue;
        
        //myvalue= myvalue.substr(1,myvalue.length-3); // remove BibLatex Curley braces
        //		console.log (myfield);

        //.replace(/\r\n/g, "<br />");
        //		console.log(myvalue);
        if (!safeRead(ArrayOfBibKeys, articleid, myfield)) {
            ArrayOfBibKeys[articleid][myfield] =  brify(ddTags[i].innerHTML); // took innerHTML instead of textContent because of microdata preservation-- 
            //valCode[0].setAttribute("id", myfield + "~" + articleid);
            //redundant, deprecated
        }
    }
    ArrayOfBibKeys[articleid][escapeConflictPrefix + "reftype"] = 
			bibmasDataTable.cell("#"+articleid,".typecolumn").node().getElementsByTagName("abbr")[0].firstChild.nodeValue;
	

    ArrayOfBibKeys[articleid][escapeConflictPrefix + "refkey"] = articleid;
    biblatexFields[escapeConflictPrefix + "refkey"] = biblatexFields[escapeConflictPrefix + "reftype"] = "A redundant copy of key/type value above, just in case you could lose the originals while exporting into your program.";


    function cleanDoi(doi) {
        return doi.replace(/^http:\/\/dx.doi.org\//, "")
    }



    var doi = safeRead(ArrayOfBibKeys, articleid, "doi");
    if (doi) ArrayOfBibKeys[articleid]["doi"] = cleanDoi(doi);

    var url = safeRead(ArrayOfBibKeys, articleid, "url");
    if ((url && url.indexOf("http://dx.doi.org/") === 0) && (!doi || (cleanDoi(url) === cleanDoi(doi)))) {

        ArrayOfBibKeys[articleid]["doi"] = url.replace(/^http:\/\/dx.doi.org\//, "");
        ArrayOfBibKeys[articleid]["url"] = undefined;

    }




    //what else? 
    //journal - journaltitle? month? date? year? address - location? numpages -pagetotal?

}






/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---              table functions              --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */



function g2A(MyAnchor, optParentInfo) {

    //2014-09-08: this function in current structure is thankfully informed by /// //cdn.datatables.net/plug-ins/725b2a2115b/api/page.jumpToData().js
    function errormsg(dimension) {
		
        if (document.getElementById(MyAnchor) || (["z","z_0"].indexOf(MyAnchor) !== -1)) 
        {
			
			return; 
		}
        // if it is an existing anchor outside the table, like top or so



        var x = "<strong>Erroneous link<\/strong> - cannot trace internal anchor for entry: <code class=key>" + MyAnchor + "<\/code>. ";
        switch (optParentInfo) {
            case "onLoading":
				
				
                x += "<br>This is a non-existing hash which was delivered with the browser URL <code>" + location.href.replace(location.hash,"") +
                    "<mark>"+location.hash +"<\/mark><\/code>. <br>Faulty hash has now been automatically removed from the URL.";
                window.location.hash = "top";
                break;
            default:
                x += "<details id=errordetails><summary>Details.. <\/summary>" +
                    "<samp>// BibMAS html version: " + document.getElementById("versioninfofield").textContent + " <br>" +
                    "// location.href: " + location.href + " <br>" +
                    "// time: " + new Date().yyyymmddThhmmse() + " <br>" +
                    "// malfunction grade: " + dimension + " <br>" +
                    "// g2A() confronted unaccountable anchor id " + MyAnchor + " <br>" +
                    "// optParentInfo: " + ((optParentInfo) ? optParentInfo : "none") + " <br>";


				x += "// arguments.callee.caller.name : " + arguments.callee.caller.name + " <br>";
                x += "// $(document.activeElement).attr('href'): " + $(document.activeElement).attr('href') + " <br>";
                x += "// $(document.activeElement).attr('onclick'): " + $(document.activeElement).attr('onclick') + " <br>";
                x += "// $(document.activeElement).parents('tr').attr('id'): " + $(document.activeElement).parents('tr').attr('id') + " <br>";
                x += "// $(document.activeElement).parents('div').attr('id'): " + $(document.activeElement).parents('div').attr('id') + " <br>";
                
                x += "// this: " + this + " <br>";
                
                




                x+=    "// <\/samp><\/details>";
                x += "This version of the bibliography seems to contain flawed anchor information. Though possibly, it might still contain the requested record information; to be sure, you might want to search this book/article manually: e.g. you could enter author, year and/or title information etc into the search filter field(s)."
                x += " <p><em>Please help us detecting flaws<\/em> and "+ 
                    mail2(mailvar1, mailvar2, mailvar3, mailvar4 + "&body=" + encodeURIComponent("I received this error: "+liBr+liBr+"\"" + stripHTML(x) + "\""), "click here to send a problem report") + 
                    
                   " - thank you!";
                x += "<p><a class=button href='javascript:showInfoBar(false)'>Close this message<\/a>"
        }
        showInfoBar(x, 1);
  
        $("#errordetails").details();

    }
	
	
    if (MyAnchor.substr(0, 1) === "#") MyAnchor = MyAnchor.substr(1, MyAnchor.length - 1);
	
	
	if (MyAnchor.substr(MyAnchor.length-5,5)=="_d4t4") {
				var errorNfo;
				var temp=MyAnchor.substr(0,MyAnchor.length-5);
				try {gNf(temp);}
				catch(err) {errorNfo=err}
				if (!errorNfo) return;
				
				}
	

    //var bibmasDataTable = $('#bibmasmaintable').DataTable();
    var entry = bibmasDataTable.row("#" + MyAnchor).node();

    //exclude malformed anchors - test if row exists by that id.
    if (!entry) {
        errormsg(1);
        return;
    }

    //it is just invisible on the page, must be elsewhere.. 
    if (!document.getElementById(MyAnchor)) {
        // find index in rows array, search applied
        var DTObj = bibmasDataTable.row("#" + MyAnchor, {
            order: 'current',
            search: 'applied',
            page: 'all'
        }).data();
        var DTAllObj = bibmasDataTable.rows({
            order: 'current',
            search: 'applied',
            page: 'all'
        }).data();
        var pos = DTAllObj.indexOf(DTObj);


        if (pos < 0) { // not found, but we know it exists from before
            var DTObj = bibmasDataTable.row("#" + MyAnchor, {
                order: 'current',
                search: 'none',
                page: 'all'
            }).data();
            var DTAllObj = bibmasDataTable.rows({
                order: 'current',
                search: 'none',
                page: 'all'
            }).data();
            var pos = DTAllObj.indexOf(DTObj);
            if (pos < 0) //should not happen (we know it exists as tr id from before)
                errormsg(2);
            else // found if no search applied > ask wheither to remove search filters
            {
                if (confirm("The selected record (" + MyAnchor + ") seems to be hidden by search filters. Do you want do deactivate search filters?")) {
                    clearSearch();
                } else return;
            };
        }
        //go elsewhere	
        var page = Math.floor(pos / bibmasDataTable.page.info().length);
        bibmasDataTable.page(page).draw(false);

    }

    if (!document.getElementById(MyAnchor)) //should never happen
        errormsg(3);
    location.hash=MyAnchor;
    
    document.getElementById(MyAnchor).scrollIntoView();
		
     //window.location = "#"+MyAnchor;
    
    //entry.focus();
    //window.scrollBy(0, -40);

    //if (optParentInfo &&(!(bibmasDataTable.row("#" + optParentInfo).node()))) {closedialogbox(optParentInfo);}

}


//function setActiveRow(articleid)
//{

/*var scroll = $(window).scrollTop();
location.hash=articleid;
$("html").scrollTop(scroll);
*/
//location="#"+articleid;
//}




function addColumnSearch() {
    //begin add search to columns 
    // http://www.datatables.net/examples/api/multi_filter.html and www.datatables.net/examples/api/multi_filter_select.html
    // DataTable
    //var bibmasDataTable = $('#bibmasmaintable').DataTable();
    // Setup - add a text input to each footer cell
    
    ///// only load visible columns
    //var footerCells = $('#bibmasmaintable tfoot td'); 
    //var headerCells = $('#bibmasmaintable thead th');
    
    ///// also load invisible columns
    var footerCells = $(bibmasDataTable.columns().footer());
    var headerCells = $(bibmasDataTable.columns().header());
       //151217: unsichtbare spalten werden hier geladen -- sie müssen später auch analog mit dem richtigen index angesprochen werden! 
       //genau das funktioniert aber nicht mit dem richtigem title-text -- 
       
    
    footerCells.each(function(i) {

		if (!$(this).hasClass('nothing')) 
		{
			/*
			 // 151217:  test
			  alert(
			"i = " + i + "\n"+
			"$(this).index() = " + $(this).index() +"\n"+ 
			"headerCells.eq($(this).index()).text() = "+ headerCells.eq($(this).index()).text() + "\n"+
			"headerCells.eq(i).text() = " + headerCells.eq(i).text());
			*/
			
			
			// var title = headerCells.eq($(this).index()).text(); //removed 151217
			///151217: changed to "i instead of $(this).index()
			var title = headerCells.eq(i).text();
			var legTitle=legalisestring(title);

			if (!$(this).hasClass('combo')) {
				///DEFAULT (no combo or datalist)
				$(this).html('<input class="searchcol nobr" id="searchfield' + legTitle + '" type="search" autocomplete=on placeholder="\u270D search ' + title + '" title="search ' + title + '" />');
			} else {
				///SPECIAL (combo resp. datalist)
				
				
				
				/*
				var entrytypesortorder={'article':0, 'suppperiodical':0, 'review':0, 'periodical':1, 'book':1,'mvbook':1,'booklet':1,'phdthesis':1,'collection':2,'mvcollection':2,'proceedings':2,'mvproceedings':2,'reference':2,'mvreference':2,'inbook':3,'suppbook':3,'incollection':4,'suppcollection':4,'inproceedings':4,'conference':4,'suppproceedings':4,'inreference':4,'suppreference':4,'manual':5,'report':5, 'online':6,'www':6,'electronic':6,'unpublished':7,'letter':8,'misc':9};
				*/
				
				$(this).html('<input id="searchfieldwithcombo_' + legTitle + '" class="searchcol nobr searchfieldwithcombo" type="search" placeholder="\u270D search ' + title + '" list="datalist_searchfieldwithcombo_' + title + '" title="search ' + title + '" />');
				var arrow = $('<label for="searchfieldwithcombo_' + legTitle + '"><a class=comboarrow href="#z" title="Dropdown proposal list for ' + title + '" id="btn_searchfieldwithcombo_' + legTitle + '">&#9776;<\/a><\/label>')
					.appendTo($(this))

				.on('click', new Function ('event',
					'var a=$(this).next(".searchcombo");'+
					'a.toggle();'+
					//var b=$(this).prev(".searchfieldwithcombo");'
					//'var pos = b.offset();'+
					//'a.offset.top += pos.top+b.style.height();a.offset.left=pos.left;'+
					'$(this).next(".searchcombo:visible").focus(); '+
					'return false;'));


/*
 new Function('event',
            '(this.value != "") ? $(this).addClass("active"): $(this).removeClass("active");'+
            'bibmasDataTable'+
                '.column("#'+$(bibmasDataTable.column(colIdx).header()).attr('id')+'")'+
                '.search(this.value)'+
                '.draw();'));
                
 */
			
				/*
				.on('click', function() {
					$(this).next(".searchcombo").toggle();
					var pos = $(this).prev(".searchfieldwithcombo").offset();
					pos.top += $(this).prev(".searchfieldwithcombo").width();
					$(this).next(".searchcombo:visible").focus(); 
					return false;
				});*/
				//$(this).firstChild.wrap("<span class=nobr><\/span>");
				
				var select = $('<select size=20 class=searchcombo><option value="" title="View all, i.e. select no search filter here for '+title+'">\u232B [all]<\/option><\/select>')
					.appendTo($(this))
					.on('click', function() {

						$(this).prev().prev(".searchfieldwithcombo").val($(this).val());
						$(this).prev().prev(".searchfieldwithcombo").trigger("keyup");
						$(this).prev().prev(".searchfieldwithcombo").focus();
						$(this).hide(100);

					})

				.keydown(function(e) {
					if (e.keyCode === 27) {
						$(this).toggle()
					} else
					if (e.keyCode === 13) {
						$(this).trigger("click");
					}
				});

				
				//select.top = $(this).prev(".searchfieldwithcombo").position.top;
				//select.left= $(this).prev(".searchfieldwithcombo").position.left;
				
				
				
	//			'var a=$(this).next(".searchcombo");var b=$(this).prev(".searchfieldwithcombo");'+
	//				'a.toggle();'+
	//				'var pos = b.offset();'+
	//				'a.top += pos.top+b.height();a.left=pos.left;'+
				
	/*
				
					'<optgroup label="in periodicals">'
						'<option value="@article" title="' +safeRead(biblatexTypes, "article") + '">@article<\/option>'
						'<option value="@review" title="' +safeRead(biblatexTypes, "review") + '">@review<\/option>'
						'<option value="@suppperiodical" title="' +safeRead(biblatexTypes, "suppperiodical") + '">@suppperiodical<\/option>'
					'<\/optgroup>'	
					
						'<option value="@periodical" title="' +safeRead(biblatexTypes, "periodical") + '">@periodical<\/option>'
						'<option value="@book" title="' +safeRead(biblatexTypes, "book") + '">@book<\/option>'
						'<option value="@article" title="' +safeRead(biblatexTypes, "article") + '">@article<\/option>'
						
						{'article':0, 'suppperiodical':0, 'review':0, 'periodical':1, 'book':1,'mvbook':1,'booklet':1,'phdthesis':1,'collection':2,'mvcollection':2,'proceedings':2,'mvproceedings':2,'reference':2,'mvreference':2,'inbook':3,'suppbook':3,'incollection':4,'suppcollection':4,'inproceedings':4,'conference':4,'suppproceedings':4,'inreference':4,'suppreference':4,'manual':5,'report':5, 'online':6,'www':6,'electronic':6,'unpublished':7,'letter':8,'misc':9};
				else*/
				
				
				{
					switch ($(this).attr("headers")) 
					{
						case "keywordscolumn_th":
						
						
						/* compress? there are rather many array operations */
								var tempArray=[];
								//splitting keywords from fields
								bibmasDataTable.column(i).data().each(function(d, j) {
									xy = stripHTML(d).split(/,|\+|=|~/);
									Array.prototype.push.apply(tempArray,xy)
								});
								
								$(tempArray)
										.each( function(index,item) 
												{
													//trim leading and ending spaces
													tempArray[index] = $.trim(item);
													}
											);
								
								
								tempArray=tempArray
										.sort(); 
										
										
								//eliminate duplicates
								  var i,
									  len=tempArray.length,
									  obj={};

								  for (i=0;i<len;i++) {
									obj[tempArray[i]]=0;
								  }
								  delete obj[""];
								  //var mystring="";
								  
								  
								  for (i in obj) {
										select.append("<option value='\"" + i + "\"'>" + i + "<\/option>")	
									//	mystring+="\n"+i;
								  }
									//popUp("keywords",mystring,"","","");
									
						break;
					
						
						
						case "s3l_th":
						select.append('<option value="\u2611">selected<\/option><option value="\u2610">unselected<\/option>');
						//	⌘	8984	⌘	2318	 	PLACE OF INTEREST SIGN
						break;
						
						case "typecolumn_th":
						bibmasDataTable.column(i).data().unique().sort().each(function(d, j) {
							xy = stripHTML(d);
							
							select.append("<option value='\"" + xy + "\"' title='" + safeRead(biblatexTypes, xy.substr(1, xy.length - 1)) + "'>" + xy + "<\/option>");
						});
						break;
						
						default:
						bibmasDataTable.column(i).data().unique().sort().each(function(d, j) {
							xy = stripHTML(d);
							
							select.append("<option value='\"" + xy + "\"'>" + xy + "<\/option>")
						
						});
					}
					
				}
				
				//$(select).wrap('<datalist size=20 class=searchcombo id="datalist_searchfieldwithcombo_' + title + '" for="searchfieldwithcombo_' + title + '"><\/datalist>');
				//$(arrow).trigger("click")
				select.hide();
			}
			/*this.innerHTML+= '<input class="jumpcol" id="jumpfield'+ title +'" type="text" placeholder="jump to next '+title+'" />' ;*/
			
		}
    });
    
    
    
//do a provisory click bind:
//http://datatables.net/forums/discussion/5141/capturing-sort-event-on-table-heading/p1

$("s3l_th").click(function() {invalidateTable()} );
$("tfoot .s3l .searchcol").on('keyup change', new Function("invalidateTable()"));

    
    
    
    
    // Apply the search
/*    bibmasDataTable.columns().eq(0).each(function(colIdx) {
        $('.searchcol', bibmasDataTable.column(colIdx).footer()).on('keyup change', function() {
            (this.value != "") ? $(this).addClass("active"): $(this).removeClass("active");
            bibmasDataTable
                .column(colIdx)
                .search(this.value)
                .draw();
        });
*/

        /*        $('.jumpcol', table.column(colIdx).footer())
        				.keydown(function(e) {
        						if (e.keyCode === 13) {
        							$('#bibmasmaintable').DataTable().page.jumpToData(this.value, colIdx);
        							
        							
        							}
        			});*/

    bibmasDataTable.columns().eq(0).each(function(colIdx) {
		
		//


		
        $('.searchcol', bibmasDataTable.column(colIdx).footer()).on('keyup change', new Function('event',
            '(this.value != "") ? $(this).addClass("active"): $(this).removeClass("active");'+
            'bibmasDataTable'+
                '.column("#'+$(bibmasDataTable.column(colIdx).header()).attr('id')+'")'+
                '.search(this.value)'+
                '.draw();'));
        //maybe add a function to markup findings (and unmark everything from previous searches)!


    });
    
    var r = $('#bibmasmaintable tfoot tr');
    r.find('td').each(function() {
        $(this).css('padding', 8);
    });
    $('#bibmasmaintable thead').append(r);
    $('#search_0').css('text-align', 'center');
    
    

$(document).mouseup(function (e)
{
    var container = $(".searchcombo");

    if (!container.is(e.target) // if the target of the click isn't the container...
        && container.has(e.target).length === 0
        && (!$(".comboarrow").is(e.target))
        ) // ... nor a descendant of the container
        
    {
        container.hide();
    }
});

    
    /*r.hide();

 var timer;
 
    $('#bibmasmaintable thead tr').find("th").each(
				function () {
								$(this).hover(function()
									{
									clearTimeout(timer);
									$('#bibmasmaintable tfoot tr').show();
									}
									, 
									function()
										{
										timer = setTimeout(function(){$('#bibmasmaintable tfoot tr').hide();},2200);
										}
									);
							}
);
	*/

    /*
        var table = $('#bibmasmaintable').DataTable();
       // Setup - add a text input to each footer cell
        $('#bibmasmaintable tfoot th').each( function (i) {
    		var title = $('#bibmasmaintable thead th').eq( $(this).index() ).text();
    			$(this).innerHTML += ( '<input class="jumpcol" id="jumpfield'+ title +'" type="text" placeholder="search '+title+'" />' );
        } );
        // Apply the jump
        table.columns().eq(0).each(function(colIdx) {
    			$('.jumpcol', table.column(colIdx).footer())
    				.keydown(function(e) {
    						if (e.keyCode === 13) {

    								g2A(this.val());	
    								
    				}
    			});
    		});
    		*/

}




//function addColumnSearch() {


	
  
    ////begin add search to columns 
    //// http://www.datatables.net/examples/api/multi_filter.html and www.datatables.net/examples/api/multi_filter_select.html
    //// DataTable
    //var bibmasDataTable = $('#bibmasmaintable').DataTable();
    //// Setup - add a text input to each footer cell
    //$('#bibmasmaintable tfoot td').each(function(i) {


        //var title = $('#bibmasmaintable thead th').eq($(this).index()).text();

        //if (!$(this).hasClass('combo')) {
            //$(this).html('<input class="searchcol" id="searchfield' + title + '" type="text" placeholder="search ' + title + '" title="search ' + title + '" />');
        //} else {
			
			//var onselectfunc=''; var onclickfunc ='onchange'+'="{'+
									
									//'$(\'#searchfield' + title + '\').val($(this).val())'+
									////'x.value=this[this.selectedIndex].value;'+
									//'.trigger(\'keyup\')'+
									//'.focus()'+
								//'}" ';
			
            //$(this).html('<input id="searchfieldwithcombo_' + title + '" class="searchcol searchfieldwithcombo" type="text" name="searchelwithval' + title + '" list="datalist_searchfieldwithcombo_' + title + '" placeholder="search ' + title + '" title="search ' + title + '" />');
          
          ///*begin datalist change*/
          
          //var select=$('<select name="searchelwithval' + title + '" '+onclickfunc+'><option value="" '+onselectfunc+'>[all @types]<\/option><\/select>')
                //.appendTo($(this))

          
          ///* old solution  
            //var arrow = $('<label for="searchfieldwithcombo_' + title + '"><a class=comboarrow href="#!" title="Dropdown proposal list for ' + title + '" id="btn_searchfieldwithcombo_' + title + '">&#9660;<\/a><\/label>')
                //.appendTo($(this))

		
            //.on('click', function() {
                //var pos = $(this).prev(".searchfieldwithcombo").offset();
                //pos.top += $(this).prev(".searchfieldwithcombo").width();
                //$(this).next(".searchcombo").toggle();
                //$(this).next(".searchcombo:visible").focus();
                //return false;
            //});
			//$(this).wrap("<span class=nobr><\/span>");
            //var select = $('<select size=20 class=searchcombo><option value="">[all types]<\/option><\/select>')
                //.appendTo($(this))
                //.on('click', function() {

                    //$(this).prev().prev(".searchfieldwithcombo").val($(this).val());
                    //$(this).prev().prev(".searchfieldwithcombo").trigger("keyup");
                    //$(this).prev().prev(".searchfieldwithcombo").focus();
                    //$(this).hide(100);

                //})

            //.keydown(function(e) {
                //if (e.keyCode === 27) {
                    //$(this).toggle()
                //} else
                //if (e.keyCode === 13) {
                    //$(this).trigger("click");
                //}
            //});*/
            
			///*end datalist change*/
            
            //bibmasDataTable.column(i).data().unique().sort().each(function(d, j) {
                //xy = stripHTML(d);
                
                //select.append('<option value="' + xy + '" title="' + safeRead(biblatexTypes, xy.substr(1, xy.length - 1)) + '" '+onselectfunc+'>' + xy + '<\/option>')
                
            //});
            //$(select).wrap('<datalist size=20 class=searchcombo id="datalist_searchfieldwithcombo_' + title + '" for="searchfieldwithcombo_' + title + '"><\/datalist>');
            ////select.hide();
        //}
        ///*this.innerHTML+= '<input class="jumpcol" id="jumpfield'+ title +'" type="text" placeholder="jump to next '+title+'" />' ;*/
    //});
    //// Apply the search
///*    bibmasDataTable.columns().eq(0).each(function(colIdx) {
        //$('.searchcol', bibmasDataTable.column(colIdx).footer()).on('keyup change', function() {
            //(this.value != "") ? $(this).addClass("active"): $(this).removeClass("active");
            //bibmasDataTable
                //.column(colIdx)
                //.search(this.value)
                //.draw();
        //});
//*/

        ///*        $('.jumpcol', table.column(colIdx).footer())
        				//.keydown(function(e) {
        						//if (e.keyCode === 13) {
        							//$('#bibmasmaintable').DataTable().page.jumpToData(this.value, colIdx);
        							
        							
        							//}
        			//});*/

    //bibmasDataTable.columns().eq(0).each(function(colIdx) {
		
		////
		
        //$('.searchcol', bibmasDataTable.column(colIdx).footer()).on('keyup change', new Function('event',
            //'(this.value != "") ? $(this).addClass("active"): $(this).removeClass("active");'+
            //'$("#bibmasmaintable").DataTable()'+
                //'.column("#'+$(bibmasDataTable.column(colIdx).header()).attr('id')+'")'+
                //'.search(this.value)'+
                //'.draw();'));
        


    //});
    //var r = $('#bibmasmaintable tfoot tr');
    //r.find('td').each(function() {
        //$(this).css('padding', 8);
    //});
    //$('#bibmasmaintable thead').append(r);
    //$('#search_0').css('text-align', 'center');
    ///*r.hide();

 //var timer;
 
    //$('#bibmasmaintable thead tr').find("th").each(
				//function () {
								//$(this).hover(function()
									//{
									//clearTimeout(timer);
									//$('#bibmasmaintable tfoot tr').show();
									//}
									//, 
									//function()
										//{
										//timer = setTimeout(function(){$('#bibmasmaintable tfoot tr').hide();},2200);
										//}
									//);
							//}
//);
	//*/

    ///*
        //var table = $('#bibmasmaintable').DataTable();
       //// Setup - add a text input to each footer cell
        //$('#bibmasmaintable tfoot th').each( function (i) {
    		//var title = $('#bibmasmaintable thead th').eq( $(this).index() ).text();
    			//$(this).innerHTML += ( '<input class="jumpcol" id="jumpfield'+ title +'" type="text" placeholder="search '+title+'" />' );
        //} );
        //// Apply the jump
        //table.columns().eq(0).each(function(colIdx) {
    			//$('.jumpcol', table.column(colIdx).footer())
    				//.keydown(function(e) {
    						//if (e.keyCode === 13) {

    								//g2A(this.val());	
    								
    				//}
    			//});
    		//});
    		//*/

//}



function updateSelected(optBeforeDTLoad)
{
var x=
(optBeforeDTLoad)
? 
bibmasDomTable.getElementsByTagName("tbody")[0].getElementsByClassNameName(".selected")
:
safeRead(bibmasDataTable.rows('.selected').data());
						
						
						x= (x[0])? x.length : 0;
                        $("#table_selected_counter").text( x );
                        $("#table_selected_text").text(" selected entr" + ((x===1)? "y":"ies") + ": ");
				
	}

function saveCookies () {
	showInfoBar("Setting Cookies..");
	updateSelected();
	createCookie(clientCookies.curSel,exportSelected(-1),7);
	}

function exportSelected(mode) 
{
	var modekey= ((mode <999) ? ["bibLaTex code","complete title set"][mode] : "compact bibl. ref.");
	
	/*//https://datatables.net/extensions/tabletools/api
	 var oTT = TableTools.fnGetInstance( 'bibmasmaintable' );
     var aSelectedTrs = oTT.fnGetSelected();
     */
     
     var aSelectedIds=[];
     //var bibmasDataTable=$('#bibmasmaintable').DataTable();
     var aSelectedTrs = bibmasDataTable.rows('.selected').nodes();
     
    $(aSelectedTrs).each   (function() {
		aSelectedIds.push ($(this).attr("id"))
		});

	if (mode!==-1) {	
	var warningmsg = "No entries selected. You can select multiple records via their checkboxes (or by <em>clicking<\/em> them while pressing <kbd>Ctrl<\/kbd> key).";
	
			if (aSelectedIds[0]==null) {
				showInfoBar(warningmsg,1);
				return;}
		showInfoBar(false,1,warningmsg)	

			var temptitle= modekey + (aSelectedIds.length>1 ? "s":"") + 
				" ["+ aSelectedIds.join(",") + "]";
			if (temptitle.length>75) temptitle=temptitle.substr(0,68)+".. etc.]"	;
			
			popUp	(temptitle, 
					 buildItemList(aSelectedIds,mode,"top"), legalisestring(modekey.toLowerCase()+"_"+aSelectedIds.join("_")),false,modekey+"_");
	}
	else 
	{
	return aSelectedIds.join(",");
	}
	
    
	

}

function reloadTable() {
  var x=(window.confirm("Clear the table saved state and reload in fresh state? "+liBr+"(This will remove all applied search filters, reset column order and visibility to default, delete your sorting and paging settings, delete other cookies etc., and then tell the browser to do a cache-independent page reload.)"));
  if(!x) return;
		{

		// remove onunload handlers
		 $(window).unbind('beforeunload');
		 $(window).unbind('unload');
		
		//clear own cookies
		for (var myProp in clientCookies)
		{
		clearCookie(clientCookies[myProp]);
		}
        //clear datatables settings
        bibmasDataTable.state.clear();
        
        window.location.hash = "top";
        //reload (true means without cache)
        
        window.location.reload(true);
    }
}


function clearSearch() {
    showInfoBar("Search reset: emptying filters (general and column-specific), restarting column filter, redrawing rows..");
    //var bibmasDataTable = $('#bibmasmaintable').DataTable();

    bibmasDataTable.search("").draw();


    bibmasDataTable.columns().eq(0).each(function(colIdx) {
        try {
            var x = $('input', bibmasDataTable.column(colIdx).footer());
            x.val("");
            x.trigger("change");
        } catch (err) {
            console.log("error while clearing search field " + colIdx + ": " + err);
            try {
                bibmasDataTable
                    .column(colIdx)
                    .search("")
                    .draw();
            } catch (err) {
                console.log("again error: " + err);
            }
        }
    });

    addColumnSearch();
    // Invalidate all rows and redraw
    invalidateTable(true)

    showInfoBar(false);
}


function invalidateTable(force) {
	
if (!stringToBoolean(bibmasDomTable.getAttribute("data-changed"))&&!force) return;

bibmasDataTable.rows().invalidate().draw();
try {bibmasDomTable.removeAttribute("data-changed")} catch(err){}
	
}


function selectRow (rowId,selectTrueFalse,updateCounter,optOperateOnDomTable) {


if (optOperateOnDomTable) 
{
	
	var myrow= document.getElementById(rowId);
	if (myrow==null) return false;
	var selCol = myrow.getElementsByClassName("s3l")[0];
}
else
{
var myrow = bibmasDataTable.row("#" + rowId).node();
var selCol = bibmasDataTable.cell("#" + rowId, ".s3l").node();
}

var mycheckbox= selCol.firstChild;
/*var saveGuard= $(rowId).attr("data-selectTime");
var ThisIsNow=new Date().yyyymmddThhmmse();
rowId.setAttribute("data-selectTime",ThisIsNow);

if (ThisIsNow===saveGuard) {alert(saveGuard);selectTrueFalse=mycheckbox.checked;}
*/

if (selectTrueFalse===undefined) var selectTrueFalse=(!$(myrow).hasClass("selected"));

if (selectTrueFalse)
{
$(myrow).addClass('selected');		
//if (!NoUpdateCheckBox) 

	try {
	mycheckbox.setAttribute("checked","checked");
	mycheckbox.checked=true;
	mycheckbox.nextSibling.replaceData(0, 1, '\u2611');
	}
	catch(err){showInfoBar("error in function selectRow(" + rowId + "): "+ err)} //			9873	⚑	2691	 	BLACK FLAG

//2691 9871  

}
else 
{
$(myrow).removeClass('selected');		
//if (!NoUpdateCheckBox) 
try{
	mycheckbox.removeAttribute("checked");
	mycheckbox.checked=false;
	mycheckbox.nextSibling.replaceData(0, 1, '\u2610');
	}
catch(err){showInfoBar("error in function selectRow(" + rowId + "): "+ err)} //				2690	 	white FLAG
//9872
}

	bibmasDomTable.setAttribute("data-changed","true");


if (updateCounter)
updateSelected(optOperateOnDomTable);
/*var MyText=document.getElementById("infobar_text");
if (rowId!=MyText.getAttribute("data-rowselect")) MyText.textContent="0";
MyText.setAttribute("data-rowselect",rowId);
showInfoBar((~~(MyText.textContent))+1);
*/
//alert(selectTrueFalse+liBr+updateCounter+liBr+invalidate);
}



function s3c (myobj) {
	selectRow(myobj.parentNode.parentNode.id,undefined,true);myobj.focus();
	
	}








/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---       Biblatec Code Export etc            --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */



function buildItemList(inputServed, mode, optParentWindow) {



function capitalizeFirstLetter(s)
{
    return s && s[0].toUpperCase() + s.slice(1);
}

function addDotIfNone(mystring)
{
	
	
	
	var mystrip=stripHTML(mystring).trim().replace(/[\)\]'"]/g,'' );
	;
	//console.log(mystrip);
		
	if  (
	      mystrip.length>0 
	       
	       & 
	    
	     ['.', '!', '?', ';', ':', ','	      
	     ].indexOf(mystrip.slice(-1)) ==  -1
	     
	     /*
	       & 
	       
	       ['.)', '!)', '?)', ';)', ':)', ',)',
	      '.]', '!]', '?]', ';]', ':]', ',]'
	     ].indexOf(mystrip.slice(-2,-1)) ==  -1
	     
	     */
	     ) 
	    
	        {mystring+=".";}
	 
	return mystring;
}



var separator="<pre hidden class=noshow>____________________<\/pre>";

//preparations
//var input=[], articleid, MyString, recordStart,recordEnd,LeftStart, LeftSide, LeftEnd, RightStart, RightSide, RightEnd1, RightEnd2, x, xx, yy, z, zz,temp1;
var input=[], articleid, MyString, recordEnd,LeftStart, LeftEnd, RightStart, RightEnd1, RightEnd2,  z;


//Variablen die für Umgebung und ForIn wichtig sind
//articleid, mode, z, 

//(input instanceof Array) ? ( articleid=input.join(",");

(typeof inputServed === 'string' || inputServed instanceof String) ? 
input.push(inputServed) : 
input=inputServed;

MyString=
"<section>";

switch (mode)
{
case 1001: //short bibl. reference


//1001 references should be formatted as in normal bibliography, i.e.: author (year): /Title/,  journal/book/higher level context, publisher if not article
MyString+=liBr+"<h1>Compact bibliography<\/h1>"+liBr+liBr+separator+liBr;




/*MyString+= 
	((input.length >1) 
	? 
	("<aside>"+
			"<dl class='inlineRL'>"+
				"<dt><strong>"+input.length+"<\/strong> selected entries&nbsp;<\/dt>"+liBr+
				"\t<dd>"+lnkIntDb(input.join(","),optParentWindow,true)+"<\/dd>"+
			"<\/dl>"+
	"<\/aside>"+liBr+liBr+separator+liBr) 
	: 
	"");
            LeftStart = "<dt class=fld>";
            LeftEnd = "<\/dt>";
            RightStart = liBr+"\t<dd class=val>";
            RightEnd1 = "<\/dd>";
            RightEnd2 = liBr+liBr;
        z =  ("abbr") ;//W3 HTML validity for dfn tags with definition content in tooltips
         recordEnd="<\/dd><\/dl><\/article>" +liBr+((input.length>1)?separator:liBr)+liBr;

/**/



MyString+="<main>"+liBr;

//this loop is for handling every single selected item one after the other.
for (var i = 0; i < input.length; i++) {
	articleid=input[i];
    assignArr2Dl(articleid);
    
    var entrytype = safeRead(ArrayOfBibKeys,articleid,escapeConflictPrefix + "reftype").toLowerCase();
	
MyString+="<article>"+liBr;


	 ///short bibl ref
		MyString+=		"<dl class='inlineRL narrowleft'>"+
						"<dt><strong>" + (i+1)+". <\/strong><\/dt>"+
						//liBr+
						"\t<dd>" ;
								

	//var ky=articleid;
	/////imported and adapted from other internal links' tooltip functionality, below
	
	try{assignArr2Dl(articleid);} catch(err){console.log(articleid+liBr+err)}
         var there = bibmasDataTable.row("#" + articleid).node();
    if (!there) {
        continue;
    }


    var aucol = bibmasDataTable.cell("#" + articleid, ".authorcolumn").node();
    var edcol = bibmasDataTable.cell("#" + articleid, ".editorcolumn").node();
    var ttcol = bibmasDataTable.cell("#" + articleid, ".titlecolumn").node();
    var yecol = bibmasDataTable.cell("#" + articleid, ".yearcolumn").node();
    var typcol = bibmasDataTable.cell("#" + articleid, ".typecolumn").node();
    
   var myauthor="", myeditor="", mytitle="", myyear="";

    try {  myauthor = aucol.getElementsByClassName("author")[0].textContent; } 
    catch (err) {   }

     try {  myeditor = edcol.getElementsByClassName("author")[0].textContent;}	
						catch (err) { 	}

    var mytitle = ttcol.getElementsByClassName("title")[0].textContent;

    try {  myyear = yecol.getElementsByTagName("time")[0].textContent; } 
    catch (err) {console.log(articleid);  
				}

    if (!myauthor) { 
		myauthor = safeRead(ArrayOfBibKeys,articleid,"author");
		
	}
    if (!myeditor) {
			myeditor = safeRead(ArrayOfBibKeys,articleid,"editor");
	  }
		
    if (!mytitle) {
		mytitle = safeRead(ArrayOfBibKeys,articleid,"title");
		if (!mytitle) mytitle="Untitled";
		
	}
 
					
    mytitle="<a class='' href=\"#" + articleid + "\" onclick=\"g2A(\'" + articleid + 
    "\'" + ");return false\" onmouseover=\"bTT(this)\" onfocus=\"bTT(this)\">" + 
    addDotIfNone(mytitle) + "<\/a>";
    
    if (!myyear) {
		myyear = safeRead(ArrayOfBibKeys,articleid,"year");
		if (!myyear) {
			
			myyear = safeRead(ArrayOfBibKeys,articleid,"date");
			if (!myyear) myyear = "undated";
			}
		}

    ////////////end import from downstairs
    
	var myurl=safeRead(ArrayOfBibKeys,articleid,"url");
	var mydoi=safeRead(ArrayOfBibKeys,articleid,"doi");
	var myurldate=safeRead(ArrayOfBibKeys,articleid,"urldate");
	if (myurldate) myurldate=new Date(myurldate.replace(/-/g, "/")).   //seems safari still does not understand ISO 8601 time format yyyy-MM-dd in Date Object, using slashes instead of dashes like yyyy/MM/dd  should do it...  
	toLocaleDateString('en-GB', 
	{ 
		year: 'numeric', month: 'short', day: '2-digit' //,localeMatcher: 'lookup', formatMatcher: 'basic'
		}
		); 
	if (myurl && myurldate) myurldate=" (visited on "+myurldate+")";
	if (mydoi) mydoi= " DOI: " + lnkEx("http://dx.doi.org/" + mydoi,mydoi) + ". ";
	if (myurl) myurl= " URL: "+ lnkEx(myurl) + myurldate + ". ";

        var myhowpublished=safeRead(ArrayOfBibKeys,articleid,"howpublished");
        if (myhowpublished) {myhowpublished= " " + addDotIfNone(capitalizeFirstLetter(myhowpublished))};
    
    var mynote=safeRead(ArrayOfBibKeys,articleid,"note");
        if (mynote) {mynote= " " + addDotIfNone(capitalizeFirstLetter(mynote))};   
	
	
switch (entrytype)
{
	
// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //

case "article": case "inperiodical": case "review" : case "suppperiodical":

	if (!myauthor) {
           if (myeditor) myauthor= myeditor + ", ed."
           else
            myauthor="Nomen Nescio";
		}
		/*var myauthor= safeRead(ArrayOfBibKeys,articleid,"author");
		if (!myauthor) 
		   {var myeditor= safeRead(ArrayOfBibKeys,articleid,"editor");
			if (myeditor) myauthor= myeditor + ", ed.";
		   }
		   
		var mytitle=  addDotIfNone(safeRead(ArrayOfBibKeys,articleid,"title"));
		
		
		var myyear=   safeRead(ArrayOfBibKeys,articleid,"year");
		*/
		var myjournal=   safeRead(ArrayOfBibKeys,articleid,"journaltitle");
		if (!myjournal) myjournal= safeRead(ArrayOfBibKeys,articleid,"journal");
		var myvolume=   safeRead(ArrayOfBibKeys,articleid,"volume");
		var mynumber=   safeRead(ArrayOfBibKeys,articleid,"number");
		var myissue=   safeRead(ArrayOfBibKeys,articleid,"issue");
		//if (mynumber)  myvolume+= "."+mynumber+" " 
		//else if (myissue) myvolume+= "."+myissue+" " ;
				var myvolnumiss =  (myvolume ? "vol. " + myvolume + " " : "") + 
				           "(" +myyear+") " + 
		                   (myissue ? "iss. " + myissue + " " : "") +
		                   (mynumber ? "nr. " + mynumber + " " : "");
		           
		
		var mypages=   safeRead(ArrayOfBibKeys,articleid,"pages");
		//if (!myjournal) myjournal=   safeRead(ArrayOfBibKeys,articleid,"journaltitle");
			
		MyString+= myauthor + " ("+myyear+"): &quot;" + (mytitle +"&quot; <i>"+myjournal+"<\/i> " + myvolnumiss).trim() +", "+ mypages;
	  break;


// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //

case "book": case "booklet": case "mvbook": case "phdthesis":case "thesis":

		/*var myauthor= safeRead(ArrayOfBibKeys,articleid,"author");
		if (!myauthor) 
		   {var myeditor= safeRead(ArrayOfBibKeys,articleid,"editor");
			if (myeditor) myauthor= myeditor + ", ed.";
		   }
		
		var mytitle=  addDotIfNone(safeRead(ArrayOfBibKeys,articleid,"title"));
		
		var myyear=   safeRead(ArrayOfBibKeys,articleid,"year");
		* */
		
		
	    if (!myauthor) {
           if (myeditor) myauthor= myeditor + ", ed."
           else
            myauthor="Nomen Nescio";
		}
		
		var myseries=   safeRead(ArrayOfBibKeys,articleid,"series");
		var mymaintitle=   safeRead(ArrayOfBibKeys,articleid,"maintitle");
		var myvolume=   safeRead(ArrayOfBibKeys,articleid,"volume");
		var mynumber=   safeRead(ArrayOfBibKeys,articleid,"number");
		var mypublisher=   safeRead(ArrayOfBibKeys,articleid,"publisher");
		if (!mypublisher) 
		  {
			  mypublisher=safeRead(ArrayOfBibKeys,articleid,"institution");
		      if (!mypublisher) mypublisher=safeRead(ArrayOfBibKeys,articleid,"school");
		   }
		var myaddress=   safeRead(ArrayOfBibKeys,articleid,"location");
		if (!myaddress) myaddress=safeRead(ArrayOfBibKeys,articleid,"address");
		if ((mymaintitle) && (myvolume)) mytitle= addDotIfNone(mymaintitle)+ " Vol. " + myvolume + ". " + mytitle;
		
			if (myseries) { 
                  myseries="("+addDotIfNone(myseries +((mynumber)? " nr. " + mynumber  : "") )+")";
		}
		
		var mypages=   safeRead(ArrayOfBibKeys,articleid,"pages");
		
//////////////
	 if (mypublisher&&myaddress) 
	             mypublisher=myaddress + ": " + mypublisher 
	 else if ((!mypublisher) && myaddress) 
	 	         mypublisher += myaddress;
///////////////

		MyString+= myauthor + " ("+myyear+"): <i>" + mytitle +"<\/i> "+myseries+ " " +  mypublisher;
		
       
       break;
// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //

    case "collection": case "mvcollection": case "mvreference": case "proceedings": case "reference":
    
    
	if (!myeditor) {
                      myeditor="Nomen Nescio";
		}
    
	
    	//var myauthor= safeRead(ArrayOfBibKeys,articleid,"author");
		//var myeditor= safeRead(ArrayOfBibKeys,articleid,"editor");
		//var mytitle=  safeRead(ArrayOfBibKeys,articleid,"title");
		//var myyear=   safeRead(ArrayOfBibKeys,articleid,"year");
		var myseries=   safeRead(ArrayOfBibKeys,articleid,"series");
		var mymaintitle=   safeRead(ArrayOfBibKeys,articleid,"maintitle");
		var myvolume=   safeRead(ArrayOfBibKeys,articleid,"volume");
		var mynumber=   safeRead(ArrayOfBibKeys,articleid,"number");
		var mypublisher=   safeRead(ArrayOfBibKeys,articleid,"publisher");
		var myaddress=   safeRead(ArrayOfBibKeys,articleid,"location");
		if (!myaddress) myaddress=safeRead(ArrayOfBibKeys,articleid,"address");
		
		if ((mymaintitle) && (myvolume)) mytitle= mymaintitle+ ". Vol. " + myvolume + ". " + mytitle;
			if (myseries) { 
			myseries=addDotIfNone("("+myseries +((mynumber)? " nr. " + mynumber  : "") )+")";
		}
		
		
		var mypages=   safeRead(ArrayOfBibKeys,articleid,"pages");
		
//////////////
	 if (mypublisher&&myaddress) 
	             mypublisher=myaddress + ": " + mypublisher 
	 else if ((!mypublisher) && myaddress) 
	 	         mypublisher += myaddress;
///////////////
	 
	 
		
		MyString+= myeditor + ", ed. ("+myyear+"): <i>" + mytitle +"<\/i> "+myseries + " " + mypublisher;
		
  
    
      break;

// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //

    case "periodical":      
    
		/*var myauthor= safeRead(ArrayOfBibKeys,articleid,"author");
		if (!myauthor) 
		   {var myeditor= safeRead(ArrayOfBibKeys,articleid,"editor");
			if (myeditor) myauthor= myeditor + ", ed.";
		   }
  		var mytitle=  safeRead(ArrayOfBibKeys,articleid,"title");
		var myyear=   safeRead(ArrayOfBibKeys,articleid,"year");
		*/
		
	    if (!myauthor) {
           if (myeditor) myauthor= myeditor + ", ed."
           else
            myauthor="Nomen Nescio";
		}
		
	    var myjournal=   safeRead(ArrayOfBibKeys,articleid,"journaltitle");
		if (!myjournal) myjournal= safeRead(ArrayOfBibKeys,articleid,"journal");
		
	    var mypublisher=   safeRead(ArrayOfBibKeys,articleid,"publisher");
		var myaddress=   safeRead(ArrayOfBibKeys,articleid,"location");
		if (!myaddress) myaddress=safeRead(ArrayOfBibKeys,articleid,"address");
		
		
		var myvolume=   safeRead(ArrayOfBibKeys,articleid,"volume");
		var mynumber=   safeRead(ArrayOfBibKeys,articleid,"number");
		var myissue=   safeRead(ArrayOfBibKeys,articleid,"issue");
		//var myissuetitle=   addDotIfNone(safeRead(ArrayOfBibKeys,articleid,"issuetitle"));
		
		
		/*
		 
		 * 
		 * 
		 * */
		var myvolnumiss =  (myvolume ? "vol. " + myvolume + " " : "") + 
		                  "(" +myyear+") " + 
		                   (myissue ? "iss. " + myissue + " " : "") +
		                   (mynumber ? "nr. " + mynumber + " " : "");
		
		
//////////////
	 if (mypublisher&&myaddress) 
	             mypublisher=myaddress + ": " + mypublisher 
	 else if ((!mypublisher) && myaddress) 
	 	         mypublisher += myaddress;
///////////////
	 
	 
		var mypages=   safeRead(ArrayOfBibKeys,articleid,"pages");
		
MyString+= myauthor + " ("+myyear+"): <i>" + (mytitle +"<\/i> <i>"+myjournal+"<\/i> " + myvolnumiss).trim() +". "+ mypublisher + (mypages? (", " + mypages):"");

		
		
			  break;

    
    
      break;

// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //

	case "incollection": case "inproceedings": case "incollection":case "conference":case "inreference": case "suppcollection":
	
	
	
	
	    if (!myauthor) {
           //if (myeditor) myauthor= myeditor + ", ed."
           //else
            myauthor="Nomen Nescio";
		}
		
		   
	    if (!myeditor) {
                      myeditor="Nomen Nescio";
		}
    
	
    	//var myauthor= safeRead(ArrayOfBibKeys,articleid,"author");
		//var myeditor= safeRead(ArrayOfBibKeys,articleid,"editor");
		//var mytitle=  safeRead(ArrayOfBibKeys,articleid,"title");
		//var myyear=   safeRead(ArrayOfBibKeys,articleid,"year");
		var mybooktitle=safeRead(ArrayOfBibKeys,articleid,"booktitle");
		if (!mybooktitle) {
			if (entrytype==("conference"||"inproceedings")) mybooktitle= safeRead(ArrayOfBibKeys,articleid,"eventtitle");
			if  (!mybooktitle) mybooktitle="Unknown Title";
		}
		var myseries=   safeRead(ArrayOfBibKeys,articleid,"series");
		var mymaintitle=   safeRead(ArrayOfBibKeys,articleid,"maintitle");
		var myvolume=   safeRead(ArrayOfBibKeys,articleid,"volume");
		var mynumber=   safeRead(ArrayOfBibKeys,articleid,"number");
		var mypublisher=   safeRead(ArrayOfBibKeys,articleid,"publisher");
		var myaddress=   safeRead(ArrayOfBibKeys,articleid,"location");
		if (!myaddress) myaddress=safeRead(ArrayOfBibKeys,articleid,"address");
		
		if ((mymaintitle) && (myvolume)) mybooktitle= mymaintitle+ ". Vol. " + myvolume + ". " + mybooktitle;
		if (myseries) { 
			myseries=addDotIfNone("("+myseries +((mynumber)? " nr. " + mynumber  : "") )+")";
		}
		
		var mypages=   safeRead(ArrayOfBibKeys,articleid,"pages");
		
//////////////
	 if (mypublisher&&myaddress) 
	             mypublisher=" "+myaddress + ": " + mypublisher 
	 else if ((!mypublisher) && myaddress) 
	 	         mypublisher= " "+myaddress;
///////////////
	 
	 
		
		MyString+= myauthor + " ("+myyear+"): &quot;" + mytitle +"&quot; In: <i>"+
		 addDotIfNone(mybooktitle) +"<\/i> Ed. by " +  myeditor +". "+myseries+  mypublisher  + (mypages? (", " + mypages):"");
		
		
	
      break;      	

// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //

	case "inbook": case "suppbook":
	
	
	
	
	    if (!myauthor) {
           //if (myeditor) myauthor= myeditor + ", ed."
           //else
            myauthor="Nomen Nescio";
		}
		
		var mybookauthor=safeRead(ArrayOfBibKeys,articleid,"bookauthor");
		if (!mybookauthor) {
           if (myeditor) mybookauthor= myeditor + " (ed.)"
           else
            mybookauthor="Nomen Nescio";
		}
		
	    
	
    	//var myauthor= safeRead(ArrayOfBibKeys,articleid,"author");
		//var myeditor= safeRead(ArrayOfBibKeys,articleid,"editor");
		//var mytitle=  safeRead(ArrayOfBibKeys,articleid,"title");
		//var myyear=   safeRead(ArrayOfBibKeys,articleid,"year");
		var mybooktitle=safeRead(ArrayOfBibKeys,articleid,"booktitle");
		var myseries=   safeRead(ArrayOfBibKeys,articleid,"series");
		var mymaintitle=   safeRead(ArrayOfBibKeys,articleid,"maintitle");
		var myvolume=   safeRead(ArrayOfBibKeys,articleid,"volume");
		var mynumber=   safeRead(ArrayOfBibKeys,articleid,"number");
		var mypublisher=   safeRead(ArrayOfBibKeys,articleid,"publisher");
		var myaddress=   safeRead(ArrayOfBibKeys,articleid,"location");
		if (!myaddress) myaddress=safeRead(ArrayOfBibKeys,articleid,"address");
		
		if ((mymaintitle) && (myvolume)) mybooktitle= mymaintitle+ ". Vol. " + myvolume + ". " + mybooktitle;
		if (myseries) { 
			myseries=addDotIfNone("("+myseries +((mynumber)? " nr. " + mynumber  : "") )+")";
		}
		
		var mypages=   safeRead(ArrayOfBibKeys,articleid,"pages");
		
//////////////
	 if (mypublisher&&myaddress) 
	             mypublisher=" "+myaddress + ": " + mypublisher 
	 else if ((!mypublisher) && myaddress) 
	 	         mypublisher =" "+ myaddress;
///////////////
	 
	 
		
		MyString+= myauthor + " ("+myyear+"): &quot;" + mytitle +"&quot; In: <i>"+
		 addDotIfNone(mybooktitle) +"<\/i> By " +  mybookauthor +". "+myseries +  mypublisher  + (mypages? (", " + mypages):"");;
		
		
	
	
      break;      

// /// /// /// /// /// /// //
/// /// /// /// /// /// /// //
// /// /// /// /// /// /// //
    case "online": case "www": case "electronic": case "manual": //featuring organization field instead of institution or publisher
    var myorganization=" " + safeRead(ArrayOfBibKeys,articleid,"organization");
    
    
	if (!myauthor) {
           if (myeditor) myauthor= myeditor + ", ed."
           else
            myauthor="Nomen Nescio";
		}
		MyString+= myauthor + " ("+myyear+"): &quot;" + mytitle+"&quot;" + myorganization;

	if ((!myurl)&&(!myhowpublished)&&(!mynote))
	{
	  //mynote=	safeRead(ArrayOfBibKeys,articleid,"addendum");//lnkint
	   //if (!mynote)
	   {	
		mynote= safeRead(ArrayOfBibKeys,articleid,"pubstate");
		if (!mynote) 
				{
				mynote= safeRead(ArrayOfBibKeys,articleid,"type");
				if (!mynote) mynote= entrytype;
				}
		
	   }
	   mynote=" "+capitalizeFirstLetter(addDotIfNone(mynote));
	}

    
	break;
	
	
    
    case "report": case "misc": case "unpublished":  default:    
    
    
	if (!myauthor) {
           if (myeditor) myauthor= myeditor + ", ed."
           else
            myauthor="Nomen Nescio";
		}
		MyString+= myauthor + " ("+myyear+"): &quot;" + mytitle+"&quot;";
	if ((!myurl)&&(!myhowpublished)&&(!mynote))
	{
	  //mynote=	safeRead(ArrayOfBibKeys,articleid,"addendum");//lnkint
	   //if (!mynote)
	   {	
		mynote= safeRead(ArrayOfBibKeys,articleid,"pubstate");
		if (!mynote) 
				{
				mynote= safeRead(ArrayOfBibKeys,articleid,"type");
				if (!mynote) mynote= entrytype;
				}
		
	   }
	   mynote=" "+capitalizeFirstLetter(addDotIfNone(mynote));
	}

    
	break;
	}



MyString=addDotIfNone(MyString).replace(/  +/g, ' ') + myhowpublished  + mynote + (mydoi ? mydoi : myurl);
/* MyString+= "   (<dfn><abbr title='" + safeRead(biblatexTypes, entrytype) + "'>" + entrytype + "<\/abbr><\/dfn> "   + 
						lnkIntDb(ArrayOfBibKeys[articleid][escapeConflictPrefix + 
								'refkey'],optParentWindow,true) + ")";
	/*
*/	
MyString+="<\/dd><\/dl>" + "<\/article>"+liBr;

}

MyString+= "<\/main>"+liBr+liBr + 
separator+liBr + 
liBr+"<aside><small>Records retrieved through BibMAS "+ 
				stripHTML(generalInfos["Version history"][generalInfos["Version history"].length - 1].h34d) + " - " + lnkEx(location.href.replace(location.hash,"")) + "<\/small><\/aside>"+liBr + 

liBr;

//1001 references should be formatted as in normal bibliography, i.e.: author (year): /Title/,  journal/book/higher level context, publisher if not article



return MyString;



break;

case 1: //title set
MyString+= 
	((input.length >1) 
	? 
	("<aside>"+
			"<dl class='inlineRL'>"+
				"<dt><strong>"+input.length+"<\/strong> selected entries&nbsp;<\/dt>"+liBr+
				"\t<dd>"+lnkIntDb(input.join(","),optParentWindow,true)+"<\/dd>"+
			"<\/dl>"+
	"<\/aside>"+liBr+liBr+separator+liBr) 
	: 
	"");
            LeftStart = "<dt class=fld>";
            LeftEnd = "<\/dt>";
            RightStart = liBr+"\t<dd class=val>";
            RightEnd1 = "<\/dd>";
            RightEnd2 = liBr+liBr;
        z =  ("abbr") ;//W3 HTML validity for dfn tags with definition content in tooltips
         recordEnd="<\/dd><\/dl><\/article>" +liBr+((input.length>1)?separator:liBr)+liBr;





MyString+="<main>"+liBr;

//this loop is for handling every single selected item one after the other.
for (var i = 0; i < input.length; i++) {
	articleid=input[i];
    assignArr2Dl(articleid);
    
    var entrytype = safeRead(ArrayOfBibKeys,articleid,escapeConflictPrefix + "reftype");
	
MyString+="<article>"+liBr+
	 ///title set
				("<dl class='inlineRL titleset'>"+
						"<dt><strong>" + ((input.length>1)?(i+1)+". ":"") +	 "entrykey<\/strong><\/dt>"+
						liBr+
						"\t<dd class=key>" + lnkIntDb(ArrayOfBibKeys[articleid][escapeConflictPrefix + 
								'refkey'],optParentWindow,true) + "<\/dd>" + liBr+liBr
						+"<dt class=typfld>record type<\/dt>"+liBr+
						"\t<dd class=typ><dfn title='"+entrytype+"'><abbr title='" + safeRead(biblatexTypes, entrytype) + "'>" + entrytype + "<\/abbr><\/dfn><\/dd>"+liBr+liBr);


// FOR IN
MyString=myForIn(articleid, mode, optParentWindow,
                 MyString, LeftStart, LeftEnd, RightStart, RightEnd1, RightEnd2, z)
         +recordEnd+ liBr+ liBr;
//if (mode==0) MyString = MyString.substr(0, MyString.length - RightEnd2.length); /// 2015-06: above line would remove the last comma before each entry's closing bracket, for standard compliance.
}

MyString+= "<\/main>"+liBr+liBr;

	





break;

case 0: //biblatex
var  bibTT=" title='bibLaTex code element'";

MyString+=
	"<aside class=comment><pre>% This file was created with JabRef 2.10." +liBr + 
			"% Encoding: UTF8<\/pre>" +liBr+liBr+
		"<dl class='inlineLL'>"+
				"<dt>"+
					"<code class='at'"+bibTT+">@<\/code><code class='typ'>comment<\/code><code class='br1'"+
					bibTT+">{<\/code><\/dt>"+
				"<dd><code>x-kbibtex-encoding=utf-8<\/code><code class='br1'"+
					bibTT+">}<\/code><\/dd>" 
		+"<\/dl>"+liBr+
	"<\/aside>"+liBr;
            LeftStart = liBr+"\t<dt><code><var class=fld>";
            LeftEnd = "<\/var><\/code><code class=equ"+bibTT+"> = <\/code><\/dt>";
            RightStart = "<dd><code class=br2"+bibTT+">{<\/code><code class=val>";
            RightEnd1 = "<\/code><code class=br2"+bibTT+">}<\/code>";
            RightEnd2 = "<code class=com"+bibTT+">,<\/code><\/dd>";
   z =  "span";//W3 HTML validity for dfn tags with definition content in tooltips
           recordEnd="<\/dd>"+liBr+"<dt><code class=br1"+bibTT+">&#125;<\/code><\/dt><dd><\/dd><\/dl><\/article>";
           
           

MyString+="<main>"+liBr;

//this loop is for handling every single selected item one after the other.
for (var i = 0; i < input.length; i++) {
	articleid=input[i];
    assignArr2Dl(articleid);
    
    var entrytype = safeRead(ArrayOfBibKeys,articleid,escapeConflictPrefix + "reftype");
	
MyString+="<article>"+liBr+


				("<dl class='inlineLL bibtextable'>"+
						"<dt><code class=at"+bibTT+">&#64;<\/code>" +
							"<code class=typ><dfn title='"+entrytype+"'><span title='" + safeRead(biblatexTypes, entrytype) + "'>" + 
							entrytype +  "<\/span><\/dfn><\/code><code class=br1"+bibTT+">&#123;<\/code><\/dt>"+
						"<dd><code class=key>" + ArrayOfBibKeys[articleid][escapeConflictPrefix + "refkey"] + "<\/code><code class=com>,<\/code><\/dd>");

// FOR IN
MyString=myForIn(articleid, mode, optParentWindow,
                 MyString, LeftStart, LeftEnd, RightStart, RightEnd1, RightEnd2, z)
         +recordEnd+ liBr+ liBr;
//if (mode==0) MyString = MyString.substr(0, MyString.length - RightEnd2.length); /// 2015-06: above line would remove the last comma before each entry's closing bracket, for standard compliance.
}

MyString+= "<\/main>"+liBr+liBr;

	MyString+=  ///biblatex
	("<aside class=comment>"+liBr+
		"<dl class='inlineLL'>"+
			"<dt>"+
				"<code class='at'"+bibTT+">@<\/code><code class='typ'>comment<\/code><code class='br1'"+
				bibTT+">{<\/code><\/dt>"+
			"<dd><code>{Number Of Records : <strong>"+input.length
				+"<\/strong> : "+ lnkIntDb(input.join(","),optParentWindow,true) +"}<\/code><code class='br1'"+
				bibTT+">}<\/code><\/dd>"+liBr+liBr+
			"<dt>"+
				"<code class='at'"+bibTT+">@<\/code><code class='typ'>comment<\/code><code class='br1'"+bibTT+">{<\/code><\/dt>"+
			"<dd><code>{Records retrieved through BibMAS "+ 
				stripHTML(generalInfos["Version history"][generalInfos["Version history"].length - 1].h34d) + " - " + lnkEx(location.href.replace(location.hash,"")) + "}<\/code><code class='br1'"+bibTT+">}<\/code><\/dd>"+
		"<\/dl>"+
	"<\/aside>");
}

	return MyString;
}








function myForIn(articleid, mode, optParentWindow,
                 MyString, LeftStart, LeftEnd, RightStart, RightEnd1, RightEnd2, z)
{
var x,xx,yy, MyString, RightSide, LeftSide;

	for (var myProp in ArrayOfBibKeys[articleid])
    {
        x = safeRead(ArrayOfBibKeys, articleid, myProp);
        if (!x && (mode>0)) continue; //don't show empty values if not biblatex mode
        xx = safeRead(biblatexFields, myProp.toLowerCase());
        if (xx) xx = myProp + ": " + xx;

        switch (myProp.toLowerCase()) {
            case escapeConflictPrefix + "reftype":
            case escapeConflictPrefix + "refkey":
                if (mode>0) continue;
                RightSide = x;
                break;

			case "keywords":
				{
					RightSide=(x.trim() ? "<ul class=keywordslist><li>"+x.replace(/,/g,"<code class=com title='Keywords separator'>,<\/code><li>") + "<\/li><\/ul>" : "")
					
					break;
				};
			
            case "doi": 
                {  RightSide = lnkEx("http://dx.doi.org/" + x, x);      break;           }

            case "pages":
                
                    RightSide = (mode===0) ? x.replace("-", "--") : x;
                    break;
                
            case "crossref": case "xref": case "related":
                    RightSide = lnkIntDb(x,optParentWindow,true);
                    break;
                
            case "month":
				if (!isNaN(x)) //if it is number
						{
							//create leading zeros
							x=Number(x).pad(2); 
							//try create tooltip with month string
							RightSide=["<abbr title='" + propName(_months, x) +"'>","<\/abbr>"].join(x);
							break;
						}
				else if (mode===0) { 
						//if it is no number AND running biblatex mode 
						//RightSide = "#" + x.substr(0, 3).toLowerCase() + "#";
						//try find its number
						RightSide= _months[x.substr(0, 3).toLowerCase()]
						if(!RightSide) {RightSide=x}
						else 
						{	//create another tooltip with month string
							RightSide= ["<abbr title='" + x +"'>","<\/abbr>"].join(RightSide);
						}
						break;
					}
				    //otherwise (no number and not biblatex mode!), proceed to default..
				
            case "timestamp":
            case "bibmas_file":
            case "bibmas_note":
            case "bibmas_src":
                if (mode===0) myProp = escapeConflictPrefix + myProp.replace(/bibmas_/, "");
            default:
                RightSide = lnkIntDb(linkify_html(x), optParentWindow);
        }

        yy = (safeRead(biblatexFields, RightSide.toLowerCase()) || safeRead(biblatexLocalizationkeys, RightSide.toLowerCase()) || safeRead(biblatexTypes, RightSide.toLowerCase()) || xx);

		

        MyString +=
            LeftStart + "<dfn title='" + myProp + "'>" +

            "<" + z + " " + ((xx) ? ("title='" + xx + "'") : "") + ">" + myProp + "<\/" + z + ">"
        + "<\/dfn>" + LeftEnd
            + RightStart + 
           ((yy === xx) ? ("<span title='" + yy + "'>" + RightSide + "<\/span>") : ("<abbr title='" + yy + "'>" + RightSide + "<\/abbr>")) 
           + RightEnd1 + RightEnd2;

    }
	return MyString;
	}



function gNf(object, info, thisText, Title) {






/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---  publication && event info etc           --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */




	function pubI(articleid) {
	var x, notableInfos = {};
		assignArr2Dl(articleid);
    
		var school = safeRead(ArrayOfBibKeys, articleid, "school");
		if (school) school = "<address class=publisher>" + school + "<\/address>";
		var institution = safeRead(ArrayOfBibKeys, articleid, "institution");
		if (institution) institution = "<address class=publisher>" + institution + "<\/address>";
		var howpublished = safeRead(ArrayOfBibKeys, articleid, "howpublished");
		var addendum = safeRead(ArrayOfBibKeys, articleid, "addendum");
		var note = safeRead(ArrayOfBibKeys, articleid, "note");
		var pubstate = safeRead(ArrayOfBibKeys, articleid, "pubstate");
		var pubtype = safeRead(ArrayOfBibKeys, articleid, "type");
		var reftype = ArrayOfBibKeys[articleid][escapeConflictPrefix + "reftype"];

		var organization = (
			( ["manual","online", "www","electronic"].indexOf(reftype) !== -1)
			 ? safeRead(ArrayOfBibKeys, articleid, "organization"):"");
		if (organization) organization = "<address class=publisher>" + organization + "<\/address>";

		var origauthor = safeRead(ArrayOfBibKeys, articleid, "origauthor");
		if (origauthor) origauthor = "<cite class=author>" + origauthor + "<\/cite>";
		
		var origaltauthor = safeRead(ArrayOfBibKeys, articleid, "origaltauthor");
		if (origaltauthor) origaltauthor = "<cite class=author>" + origaltauthor + "<\/cite>";
		
		var origbookauthor = safeRead(ArrayOfBibKeys, articleid, "origbookauthor");
		if (origbookauthor) origbookauthor = "<cite class=author>" + origbookauthor + "<\/cite>";
		
		var origdate = safeRead(ArrayOfBibKeys, articleid, "origdate");
		if (origdate) origdate = "<time>" + origdate + "<\/time>";
		var origyear = safeRead(ArrayOfBibKeys, articleid, "origyear");
		if (origyear) origyear = "<time>" + origyear + "<\/time>";
		
		var origmonth = safeRead(ArrayOfBibKeys, articleid, "origmonth");
		if (origmonth) origmonth = "<time>" + origmonth + "<\/time>";
		var origedition = safeRead(ArrayOfBibKeys, articleid, "origedition");
		var origjournal = safeRead(ArrayOfBibKeys, articleid, "origjournal");
		if (origjournal) origjournal = "<cite class=jtitle>" + origjournal + "<\/cite>";
		
		var origaltjournal = safeRead(ArrayOfBibKeys, articleid, "origaltjournal");
		if (origaltjournal) origaltjournal = "<cite class=jtitle>" + origaltjournal + "<\/cite>";
		
		var origaltjournaltitle = safeRead(ArrayOfBibKeys, articleid, "origaltjournaltitle");
		if (origaltjournaltitle) origaltjournaltitle = "<cite class=jtitle>" + origaltjournaltitle + "<\/cite>";
		
		
		var origshortjournal = safeRead(ArrayOfBibKeys, articleid, "origshortjournal");
		if (origshortjournal) origshortjournal = "<abbr class=jtitle>" + origshortjournal + "<\/abbr>";
		
		
		var origaltshortjournal = safeRead(ArrayOfBibKeys, articleid, "origaltshortjournal");
		if (origaltshortjournal) origaltshortjournal = "<cite class=jtitle>" + origaltshortjournal + "<\/cite>";
		
		var origbooksubtitle = safeRead(ArrayOfBibKeys, articleid, "origbooksubtitle");
		if (origbooksubtitle) origbooksubtitle = "<cite class=bsubtitle>" + origbooksubtitle + "<\/cite>";
		
		
		var origbooktitle = safeRead(ArrayOfBibKeys, articleid, "origbooktitle");
		if (origbooktitle) origbooktitle = "<cite class=btitle>" + origbooktitle + "<\/cite>";
		
		
		var origaltbooktitle = safeRead(ArrayOfBibKeys, articleid, "origaltbooktitle");
		if (origaltbooktitle) origaltbooktitle = "<cite class=btitle>" + origaltbooktitle + "<\/cite>";
		
		var origaltbooksubtitle = safeRead(ArrayOfBibKeys, articleid, "origaltbooksubtitle");
		if (origaltbooksubtitle) origaltbooksubtitle = "<cite class=bsubtitle>" + origaltbooksubtitle + "<\/cite>";
		
		
		
		var origjournaltitle = safeRead(ArrayOfBibKeys, articleid, "origjournaltitle");
		if (origjournaltitle) origjournaltitle = "<cite class=jtitle>" + origjournaltitle + "<\/cite>";
		
		
		var origlanguage = safeRead(ArrayOfBibKeys, articleid, "origlanguage");
		var origlocation = safeRead(ArrayOfBibKeys, articleid, "origlocation");
		if (origlocation) origlocation = "<address class=publisher>" + origlocation + "<\/address>";
		var origpages = safeRead(ArrayOfBibKeys, articleid, "origpages");
		var origpagetotal = safeRead(ArrayOfBibKeys, articleid, "origpagetotal");
		
		var origchapter = safeRead(ArrayOfBibKeys, articleid, "origchapter");
		
		var origpublisher = safeRead(ArrayOfBibKeys, articleid, "origpublisher");
		if (origpublisher) origpublisher = "<address class=publisher>" + origpublisher + "<\/address>";
		var origseries = safeRead(ArrayOfBibKeys, articleid, "origseries");



		
		if (origseries) origseries = "<cite class=stitle>" + origseries + "<\/cite>";
		var origsubtitle = safeRead(ArrayOfBibKeys, articleid, "origsubtitle");
		if (origsubtitle) origsubtitle = "<cite class=subtitle>" + origsubtitle + "<\/cite>";
		var origtitle = safeRead(ArrayOfBibKeys, articleid, "origtitle");
		if (origtitle) origtitle = "<cite class=title>" + origtitle + "<\/cite>";
		
var origalttitle = safeRead(ArrayOfBibKeys, articleid, "origalttitle");
		if (origalttitle) origalttitle = "<cite class=title>" + origalttitle + "<\/cite>";
		
		var origaltsubtitle = safeRead(ArrayOfBibKeys, articleid, "origaltsubtitle");
		if (origaltsubtitle) origaltsubtitle = "<cite class=title>" + origaltsubtitle + "<\/cite>";
		
		
		
		
		var origvolume = safeRead(ArrayOfBibKeys, articleid, "origvolume");
		var reprintdate = safeRead(ArrayOfBibKeys, articleid, "reprintdate");
		if (reprintdate) reprintdate = "<time>" + reprintdate + "<\/time>";
		var reprintissn = safeRead(ArrayOfBibKeys, articleid, "reprintissn");
		
		var reprintlocation = safeRead(ArrayOfBibKeys, articleid, "reprintlocation");
		if (reprintlocation) reprintlocation = "<address class=publisher>" + reprintlocation + "<\/address>";
		var reprintpublisher = safeRead(ArrayOfBibKeys, articleid, "reprintpublisher");
		if (reprintpublisher) reprintpublisher = "<address class=publisher>" + reprintpublisher + "<\/address>";
		var reprintseries = safeRead(ArrayOfBibKeys, articleid, "reprintseries");
		if (reprintseries) reprintseries = "<cite class=stitle>" + reprintseries + "<\/cite>";
		var reprinttitle = safeRead(ArrayOfBibKeys, articleid, "reprinttitle");
		if (reprinttitle) reprinttitle = "<cite class=title>" + reprinttitle + "<\/cite>";
		var reprinturl = safeRead(ArrayOfBibKeys, articleid, "reprinturl");
		var reprintyear = safeRead(ArrayOfBibKeys, articleid, "reprintyear");
		if (reprintyear) reprintyear = "<time>" + reprintyear + "<\/time>";


		var origtype = safeRead(ArrayOfBibKeys, articleid, "origtype");
		var origeditor = safeRead(ArrayOfBibKeys, articleid, "origeditor");
		if (origeditor) origeditor = "<cite class=author>" + origeditor + "<\/cite>";
		
		var origalteditor = safeRead(ArrayOfBibKeys, articleid, "origalteditor");
		if (origalteditor) origalteditor = "<cite class=author>" + origalteditor + "<\/cite>";
		
		var originstitution =  safeRead(ArrayOfBibKeys, articleid, "originstitution");
		if (originstitution) originstitution = "<address class=publisher>" + originstitution + "<\/address>";
		var orighowpublished =  safeRead(ArrayOfBibKeys, articleid, "orighowpublished");
		var origisbn = safeRead(ArrayOfBibKeys, articleid, "origisbn");
		var origissn = safeRead(ArrayOfBibKeys, articleid, "origissn");
		var origissue=safeRead(ArrayOfBibKeys, articleid, "origissue");
		var orignumber=safeRead(ArrayOfBibKeys, articleid, "orignumber");
		
		var origoclc = safeRead(ArrayOfBibKeys, articleid, "origoclc");
		
		var origurl = safeRead(ArrayOfBibKeys, articleid, "origurl");
		
		
		var reprinttype = safeRead(ArrayOfBibKeys, articleid, "reprinttype");
		var reprinteditor = safeRead(ArrayOfBibKeys, articleid, "reprinteditor");
		if (reprinteditor) reprinteditor = "<cite class=author>" + reprinteditor + "<\/cite>";
		
		
		var reprintedition = safeRead(ArrayOfBibKeys, articleid, "reprintedition");
		
		var reprintbookauthor = safeRead(ArrayOfBibKeys, articleid, "reprintbookauthor");
		if (reprintbookauthor) reprintbookauthor = "<cite class=author>" + reprintbookauthor + "<\/cite>";
		
		var reprintbooktitle = safeRead(ArrayOfBibKeys, articleid, "reprintbooktitle");
		if (reprintbooktitle) reprintbooktitle = "<cite class=btitle>" + reprintbooktitle + "<\/cite>";
		var reprintinstitution  = safeRead(ArrayOfBibKeys, articleid, "reprintinstitution"); 
		if (reprintinstitution) reprintinstitution = "<address class=publisher>" + reprintinstitution + "<\/address>";
		var reprintpages  = safeRead(ArrayOfBibKeys, articleid, "reprintpages"); 
		
		
		var reprintvolume  = safeRead(ArrayOfBibKeys, articleid, "reprintvolume"); 
		var reprintnumber  = safeRead(ArrayOfBibKeys, articleid, "reprintnumber"); 
		var reprintissue  = safeRead(ArrayOfBibKeys, articleid, "reprintissue"); 
		
		var reprintchapter  = safeRead(ArrayOfBibKeys, articleid, "reprintchapter"); 
		
		var reprinthowpublished = safeRead(ArrayOfBibKeys, articleid, "reprinthowpublished");
		var reprintnote = safeRead(ArrayOfBibKeys, articleid, "reprintnote");
		
		var reprintisbn = safeRead(ArrayOfBibKeys, articleid, "reprintisbn");
		

		if (school || institution || organization || howpublished || pubstate || note || addendum || pubtype) {
			x = "additional publication info for this record";
			notableInfos[x] = new Object;
			if (school || institution)
				notableInfos[x]["university or some other institution (e.g. for theses, reports)"] = (institution + ((school && institution) ? "/" : "") + school);
			if (organization)
				notableInfos[x]["organization(s) that published a manual or an online resource"] = organization;
			if (pubtype)
				notableInfos[x]["type of publication"] = pubtype;
			if (pubstate)
				notableInfos[x]["publication state of the work"] = pubstate;
			if (howpublished)
				notableInfos[x]["notice for unusual publications"] = howpublished;
			if (note || addendum)
				notableInfos[x]["miscellaneous bibliographic data"] = addendum + ((note && addendum) ? " / " : "") + note;
		}
		if (origauthor || origaltauthor || origdate || origyear || origmonth || origedition || origjournal || origshortjournal || origaltjournal || origaltjournaltitle|| origaltshortjournal || origbookauthor || origbooktitle || origbooksubtitle || origaltbooktitle || origaltbooksubtitle ||  origjournaltitle || origlanguage || origlocation || origpages ||origpagetotal || origchapter || origpublisher || origseries || origsubtitle || origtitle || origalttitle|| origaltsubtitle|| origvolume ||origissue||orignumber|| origtype || origurl || originstitution || orighowpublished || origisbn || origoclc || origissn || origeditor || origalteditor) {
			x = "original publication";
			notableInfos[x] = new Object;
			if (origlanguage)
				notableInfos[x]["language"] = origlanguage;
			if (origauthor)
				notableInfos[x]["author"] = origauthor;
			if (origaltauthor)
				notableInfos[x]["alt. author"] = origaltauthor;
			if (origbookauthor)
				notableInfos[x]["book author"] = origbookauthor;
				
				
			if (origeditor)
				notableInfos[x]["editor"] = origeditor;
			if (origalteditor)
				notableInfos[x]["alt. editor"] = origalteditor;
			if (origdate || origyear)
				notableInfos[x]["year/date"] = origyear  +  ((origyear &&origdate) ? " [" : "") + origdate + ((origyear &&origdate) ? "]" : "");
			if (origmonth)
				notableInfos[x]["month"] = origmonth;
			if (origtitle || origsubtitle)
				notableInfos[x]["title"] = origtitle + ((origtitle && origsubtitle) ? ": " : "") + origsubtitle;
			
			if (origalttitle || origaltsubtitle)
				notableInfos[x]["alt. title"] = origalttitle + ((origalttitle && origaltsubtitle) ? ": " : "") + origaltsubtitle;
			
			
			if (origbooktitle || origbooksubtitle)
				notableInfos[x]["book title"] = origbooktitle + ((origbooktitle && origbooksubtitle) ? ": " : "") + origbooksubtitle;	
			
			if (origaltbooktitle || origaltbooksubtitle)
				notableInfos[x]["alt. book title"] = origaltbooktitle + ((origaltbooktitle && origaltbooksubtitle) ? ": " : "") + origaltbooksubtitle;	
			
			
			if (origedition)
				notableInfos[x]["edition"] = origedition;
			if (origjournal || origjournaltitle || origshortjournal)
				notableInfos[x]["journal"] = origjournal + ((origjournal && origjournaltitle) ? "/" : "") + origjournaltitle + (origshortjournal ? " [" + origshortjournal + "]" : "");
			
			if (origaltjournal || origaltjournaltitle || origaltshortjournal)
				notableInfos[x]["alt. journal"] = origaltjournal + ((origaltjournal && origaltjournaltitle) ? "/" : "") + origaltjournaltitle + (origaltshortjournal ? " [" + origaltshortjournal + "]" :"");
				
			if (origbooktitle)
				notableInfos[x]["book title"] = origbooktitle;
			if (origvolume)
				notableInfos[x]["volume"] = origvolume;
			if (origissue)
				notableInfos[x]["issue"] = origissue;
			if (orignumber)
				notableInfos[x]["number"] = orignumber;
			if (origpages)
				notableInfos[x]["pages"] = origpages;
			if (origpagetotal)
				notableInfos[x]["total pages"] = origpagetotal;
			if (origchapter)
				notableInfos[x]["chapter"] = origchapter;
			if (origseries)
				notableInfos[x]["series"] = origseries;
			if (originstitution)
				notableInfos[x]["institution"] = originstitution;
			if (origlocation || origpublisher)
				notableInfos[x]["publisher"] = origlocation + ((origlocation && origpublisher) ? ": " : "") + origpublisher;
			if (origtype)
				notableInfos[x]["type of publication"] = origtype;
			if (origurl)
				notableInfos[x]["URL"] = origurl;
			
			if (orighowpublished)
				notableInfos[x]["publication mode"] = orighowpublished;
			if (origisbn)
				notableInfos[x]["ISBN"] = origisbn;
			if (origissn)
				notableInfos[x]["ISSN"] = origissn;
			if (origoclc)
				notableInfos[x]["OCLC"] = origoclc;
		}
		
		var reprinttype = safeRead(ArrayOfBibKeys, articleid, "reprinttype");
		
		
		
		
		
		if (reprintdate || reprintissn || reprintlocation || reprintpublisher || reprintseries || reprinttitle || reprinturl || reprintyear || reprinttype ||  reprintedition || reprinteditor || reprintbookauthor|| reprintbooktitle || reprintinstitution || reprintpages || reprintvolume || reprintnumber || reprintissue ||reprintchapter|| reprinthowpublished || reprintnote|| reprintisbn) {
			x = "reprinted";
			notableInfos[x] = new Object;
			if (reprintyear || reprintdate)
				notableInfos[x]["year/date"] = reprintyear + ((reprintdate && reprintyear) ? "/" : "") + reprintdate;
			if (reprinttitle)
				notableInfos[x]["title"] = reprinttitle;
			if (reprintissn)
				notableInfos[x]["issn"] = reprintissn;
			if (reprintbooktitle)
				notableInfos[x]["book title"] = reprintbooktitle;
			if (reprinteditor)
				notableInfos[x]["editor"] = reprinteditor;
			if (reprintbookauthor)
				notableInfos[x]["bookauthor"] = reprintbookauthor;
			
			if ( reprintedition)
				notableInfos[x]["edition"] =  reprintedition;
			
			
			if ( reprintvolume)
				notableInfos[x]["volume"] =  reprintvolume;
			
			if ( reprintnumber)
				notableInfos[x]["number"] =  reprintnumber;
			
			if ( reprintissue)
				notableInfos[x]["issue"] =  reprintissue;
			
			
			if (reprintpages)
				notableInfos[x]["pages"] = reprintpages;
			if (reprintchapter)
				notableInfos[x]["chapter"] = reprintchapter;
			
			if (reprintseries)
				notableInfos[x]["series"] = reprintseries;
			if (reprintinstitution)
				notableInfos[x]["institution"] = reprintinstitution;
			
			if (reprintlocation || reprintpublisher)
				notableInfos[x]["publisher"] = reprintlocation + ((reprintlocation && reprintpublisher) ? ": " : "") + reprintpublisher;
			
		    if (reprinttype)
				notableInfos[x]["type of publication"] = reprinttype;
			if (reprinthowpublished)
				notableInfos[x]["publication mode"] = reprinthowpublished;
			
			if (reprintnote)
				notableInfos[x]["miscellaneous bibliographic data"] = reprintnote;
				
			if (reprintisbn)
				notableInfos[x]["ISBN"] = reprintisbn;
		
			if (reprinturl)
				notableInfos[x]["URL"] = reprinturl;
		}
		return nestedObject2DL(notableInfos, "details", articleid);
	}


	function evI(articleid) {
	var x, eventInfo={};
	assignArr2Dl(articleid);
		var eventtitle = safeRead(ArrayOfBibKeys, articleid, "eventtitle");
		if (eventtitle) eventtitle = "<cite class=title>" + eventtitle + "<\/cite>";
		var eventsubtitle = safeRead(ArrayOfBibKeys, articleid, "eventsubtitle");
		if (eventsubtitle) eventsubtitle = "<cite class=subtitle>" + eventsubtitle + "<\/cite>";
		var eventtitleaddon = safeRead(ArrayOfBibKeys, articleid, "eventtitleaddon");
		if (eventtitleaddon) eventtitleaddon = "<cite class=ttladd>" + eventtitleaddon + "<\/cite>";
		var shorteventtitle = safeRead(ArrayOfBibKeys, articleid, "shorteventtitle");
		if (shorteventtitle) shorteventtitle = "<abbr class=title>" + eventtitleaddon + "<\/abbr>";
		var eventdate = safeRead(ArrayOfBibKeys, articleid, "eventdate");
		if (eventdate) eventdate = "<time>" + eventdate + "<\/time>";
		var venue = safeRead(ArrayOfBibKeys, articleid, "venue");
		if (venue) venue = "<address class=publisher>" + venue + "<\/address>";
		var organization = safeRead(ArrayOfBibKeys, articleid, "organization");
		if (organization) organization = "<address class=publisher>" + organization + "<\/address>";
		
		x = "Underlying conference, symposium, or some other event";
		eventInfo[x] = new Object;
		if (eventtitle || eventsubtitle || eventtitleaddon || shorteventtitle)
			eventInfo[x]["title"] = eventtitle + ((eventtitle && eventsubtitle) ? ": " : "") + eventsubtitle + (((eventtitle || eventsubtitle) && eventtitleaddon) ? ". " : "") + eventtitleaddon + (((eventtitle || eventsubtitle || eventtitleaddon) && shorteventtitle) ? " " : "") + shorteventtitle;
		if (eventdate)
			eventInfo[x]["date/duration"] = eventdate;
		if (venue)
			eventInfo[x]["location of event (venue)"] = venue;
		if (organization)
			eventInfo[x]["sponsoring organization(s)"] = organization;

		return nestedObject2DL(eventInfo, "details_"+articleid, articleid);
	}

	function relatedEntries (articleid) {
		var x, relInfos={};
    assignArr2Dl(articleid);		
		var relCite= safeRead (ArrayOfBibKeys, articleid,"related");
		if (relCite) {
			x="Relationship to other record(s):"; relInfos[x]= new Object;
			
			var  desc;
			var reltype=safeRead(ArrayOfBibKeys,articleid,"relatedtype");
			
			if (reltype=="") reltype="misc";
			
			 	var tooltip=safeRead(biblatexLocalizationkeys,reltype);
			 	
			 	
			 	
			 	
			 	
				var relstring=safeRead(ArrayOfBibKeys,articleid,"relatedstring");
				
				if (tooltip) tooltip=" title='" + reltype + ": " + tooltip+"' ";
				
				
				
				
				
				desc= "Type of relation: <em>"+
				relstring + "<\/em> [" 
				
				+"<code>" + (tooltip ? ("<abbr"+tooltip+">"+reltype +"<\/abbr>" ) : (reltype) ) + "<\/code>" 
				+"]"
				;
				
				
				
				
			
			
			
				
				
				
			
			relInfos[x][desc] = lnkIntDb(relCite,"details_"+articleid,true);	
				
				
				var relopt = safeRead(ArrayOfBibKeys,articleid,"relatedoptions");
				if (relopt) relInfos[x]["options to set on the related entry record(s)"] = relopt;
		
		return nestedObject2DL(relInfos, "details_"+articleid, articleid);
		}
		}

	function nestedObject2DL(obj, classN, optTransporter) {

		var out = "";
		for (var mycluster in obj) {
			out += "<dl class=headedlist><dt>" + mycluster + "<\/dt><dd><dl class='"+classN+"'>";
			for (var myprop in obj[mycluster]) {
				out += "<dt>" + myprop + ": <\/dt><dd>" + lnkIntDb(linkify_html(obj[mycluster][myprop]), optTransporter) + "<\/dd>"
			}
			out += "<\/dl><\/dd><\/dl>";

		}
		return out;
	}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---  info function                               --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */




var articleid=$(object).parents("tr").attr("id")||object;
//console.log(articleid);
//alert(articleid);
assignArr2Dl(articleid);
var shortkeys=
		{0: "titleset",
		 1: "biblatex",
		 2: "abstract",
		 3: "keywords",
		 4: "contents",
		 5: "review",
		 6: "reviewof",
		 7: "event",
		 8: "publication",
		 9: "related"}
        
		info=safeRead(shortkeys,info)||shortkeys[0];
		
        var optParentWindow = windowPrefix+info + "_" + articleid ;
		//alert(optParentWindow);

        if (!thisText) {
            switch (info) {
                case ("biblatex"):
                    thisText = buildItemList(articleid,0,optParentWindow);
                    break;
                case ("titleset"):
                    //		console.log("gNf: Calling buildItemList for "+ articleid);
                    /*var x=document.getElementById("d4t4_" + articleid).cloneNode(true);
                    x.getElementsByTagName("dl")[0].className="inlineRL";
                    thisText = lnkIntDb(linkify_html(x.innerHTML));*/
                    thisText = buildItemList(articleid, 1,optParentWindow);
                    break;
                case ("event"):
					thisText=evI(articleid);
					break;
				case ("publication"):
					thisText=pubI(articleid);
					break;
				case ("related"):
					thisText=relatedEntries(articleid);
					break;
                default:
                    var wrap = {
                        "keywords": ["<p>", "<\/p>"],
                        "contents": ["<p>", "<\/p>"],
                        "abstract": ["<blockquote><p>", "<\/p><\/blockquote>"],
                        "review": ["<p><em>This work has been reviewed  as follows: <\/em><br><cite>", "<\/cite>"],
                        "reviewof": ["<p><em>This is a review and refers to: <\/em><br><cite>", "<\/cite>"],
                        "0815": ["<p>", "<\/p>"]
                    };
                    thisText = (safeRead(wrap, info) || wrap["0815"]).join(lnkIntDb(linkify_html(safeRead(ArrayOfBibKeys,articleid,info)), articleid));

            }
        } else {
            thisText = lnkIntDb(linkify_html(thisText), articleid)
        };
        
        if (!Title) {
            switch (info) {
                case ("reviewof"):
                    Title = "reviewed work(s)"
                    break;
                case ("biblatex"):
                    Title = "bibLaTex code";
                    break;
                case ("titleset"):
                    Title = "complete title set";
                    break;
                default:
                    Title = info;
            }
        }
/*
        if (onlyReturnString) {
            return thisText
        };
*/
	switch (info)
	{
		case "titleset": case "biblatex":
        popUp(Title, thisText, optParentWindow, articleid, info);
        break;
        case "abstract": case "keywords": case "contents": case "review": case "reviewof": case "event": case "publication": case "related":
        cTT(object,thisText,optParentWindow);
        break;
	}



    }
  


/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---  build tooltips & details                --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */



function bTT(element, mode) {
	
    /*    switch (element.parentNode.tagName.toUpperCase()) {
            case ("SUMMARY"):
                return;
        }
    */
    //var ref = element.getAttribute("onclick");
    //var extr= /javascript:g2A\('(.*)'/;
    //var extr = /^g2A\('(\w+[0-9]*\w*)'/;
    //var ky = extr.exec(ref)[1];
    var ref = element.getAttribute("href");
    var ky = ref.substr(1, ref.length - 1);
    try{assignArr2Dl(ky);} catch(err){console.log(ky+liBr+err)}
    //var bibmasDataTable = $('#bibmasmaintable').DataTable()
    var there = bibmasDataTable.row("#" + ky).node();

    if (!there) {
        var x = cTT(element, "<div class=attention><\/div><STRONG>Erroneous link<\/STRONG> - <BR>can't trace internal anchor for entry: <CODE class=key>" + ky +
            "<\/CODE> <BR>Please report this problem. Click the link for more information.", mode, false, true);
        if (!mode)
            try {
                x.firstChild.style.textDecoration = "line-through"
                
            } catch (err) {
                x.style.textDecoration = "line-through"
            }
        return;
    }


    var aucol = bibmasDataTable.cell("#" + ky, ".authorcolumn").node();
    var edcol = bibmasDataTable.cell("#" + ky, ".editorcolumn").node();
    var ttcol = bibmasDataTable.cell("#" + ky, ".titlecolumn").node();
    var yecol = bibmasDataTable.cell("#" + ky, ".yearcolumn").node();
    var typcol = bibmasDataTable.cell("#" + ky, ".typecolumn").node();


    try { var name = aucol.getElementsByClassName("author")[0].textContent; } 
    catch (err) {   if (!name) 
						try { name = edcol.getElementsByClassName("author")[0].textContent;}	
						catch (err) { var error = "error in function BlTl while getting author for entry " + ky + " - " + err;
										console.log(error);
									}
				}

    var titl = ttcol.getElementsByClassName("title")[0].textContent;

    try {  var year = yecol.getElementsByTagName("time")[0].textContent; } 
    catch (err) {  var error = "error in function BlTl while getting time for entry " + ky + " - " + err;
					console.log(error);
				}

    if (!name) { 
		name = safeRead(ArrayOfBibKeys,ky,"author");
		if (!name) {
			name = safeRead(ArrayOfBibKeys,ky,"editor");
			if (!name) name = "unknown author(s)";
		}
	}
    
    if (!titl) titl = safeRead(ArrayOfBibKeys,ky,"title");
    if (!year) {
		year = safeRead(ArrayOfBibKeys,ky,"year");
		if (!year) {
			year = safeRead(ArrayOfBibKeys,ky,"date");
			if (!year) year = "undated";
			}
		}

    
    
    
	var entrytype=safeRead(ArrayOfBibKeys,ky,escapeConflictPrefix + "reftype");
    cTT(	element, 
    "<a class=in href=\"javascript:g2A('" + ky + "')\">internal anchor link<\/a> <br><em>" + 
    
    "<dfn title='"+entrytype+"'><span title='" + safeRead(biblatexTypes, entrytype) + "'>" + 
							entrytype +  "<\/span><\/dfn>"
    
     + 
    "<\/em> <br><cite class=title>" + titl + "<\/cite> <br>(<time>" + year +
        "<\/time>)<br> by <cite class='author caps'>" + name + "<\/cite>", mode, false, true);

}




