
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/// ---              dialog box                   --- ///
/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * */



function popUp(Title, thisText, windowtitle, articleid, info, displaymode, element) {




    if (!stringToBoolean(windowtitle)) windowtitle = windowPrefix+legalisestring(Title);
    var x = legalisestring(windowtitle);
    var MyDialogBodyId =  x + "_inner_body";
    var MySelAllButtId = 'selAllButt_' + x;
    var MySaveAsFNtextfieldId = 'saveAsInputText_' + x;
    var ToggleView = "toggleRaw_" + x;
    if (info.toLowerCase().substr(0,8) === "biblatex")
		{
			var fileext =  "bib";
			var mimetype= "text/x-bibtex";
		}
	else
		{	
			var fileext =  "txt";
			var mimetype= "text/plain";
		}
	
    var defaultFileName = (stringToBoolean(articleid)) ? articleid : x.substr(0,50);

    var fullContent = document.createElement("div");
    var header = document.createElement("div");
    header.className = "dialogheader";
    x = document.createElement("h3");
    x.textContent = "\u24D8 " + Title;
    header.appendChild(x);
    header.className = "dialogheader";
    if (stringToBoolean(articleid)) {
        x = document.createElement("code");
        x.innerHTML = "[" + lnkIntDb(articleid,windowtitle,true) + "]";
        header.appendChild(x);
    }
    fullContent.appendChild(header);


    //formerly main was here

    var actionform = document.createElement("form");
    actionform.className = "dialgcmdbar"

    y = document.createElement("label");


    x = document.createElement("input");
    x.setAttribute("type", "radio");
    x.id = ToggleView + "_0";
    x.value = "formatted";
    x.setAttribute("tabindex", "101");
    x.setAttribute("checked", "checked");
    x.setAttribute("name", "toggleView");
    x.setAttribute("onclick",
        "{var x='" + MyDialogBodyId + "';"+
        "document.getElementById(x+'_rawtext').style.display='none';document.getElementById(x+'_formatted').style.display='block';}");
        /* if (document.getElementById(x+'_rawtext').value != decodeURIComponent($('#'+x).attr('origrawtext'))) showInfoBar('You changed the raw text. This is just an apology that the formatted text will not automatically adapt.',1);"+*/
    y.appendChild(x);
    y.appendChild(document.createTextNode("formatted"));
    actionform.appendChild(y);

    //			decodeURIComponent($(MyDialogBodyId).attr("origrawtext"))            
    //function convert2raw() 

    y = document.createElement("label");


    x = document.createElement("input");
    x.setAttribute("type", "radio");
    x.value = "raw";
    x.setAttribute("name", "toggleView");
    x.id = ToggleView + "_1";
    x.setAttribute("tabindex", "102");
    x.setAttribute("onclick", "{var x='" + MyDialogBodyId + "';"+
			"document.getElementById(x+'_formatted').style.display='none';document.getElementById(x+'_rawtext').style.display='block'}");
        
        /* if (document.getElementById(x+'_formatted').innerHTML != decodeURIComponent($('#'+x).attr('origformatted'))) showInfoBar('You changed the formatted text. This is just a warning that the raw text will not adapt automatically.<br>If you want to export the <em>changed<\/em> text, you should <a class=button href=\\'#i\\' onclick=\\'{ document.getElementById(&quot;'+x+'_rawtext&quot;).value=convert2raw(&quot;'+x+'&quot;);return false}\\'>adapt now<\/a>.',1);"+*/
        //"alert(document.getElementById(x+'_formatted').innerHTML +'\\n\\n' +decodeURIComponent($('#'+x).attr('origformatted')));"+
    y.appendChild(x);
    y.appendChild(document.createTextNode("raw"));
    actionform.appendChild(y);



    
    x = document.createElement("input");
    x.setAttribute("tabindex", "103");
    x.setAttribute("type", "button");
    x.setAttribute("onclick", "{(document.getElementById('" + ToggleView + "_1').checked)? document.getElementById('" + MyDialogBodyId + "_rawtext').select() : slctT(document.getElementById('" + MyDialogBodyId + "_formatted').firstChild)}");
    //x.className = "button";
    x.id = MySelAllButtId;
    x.value = "\u25CC select all"; //+stripHTML(thisText).length; //25A4
    actionform.appendChild(x);
  
    var filesavertext = document.createElement("label");
    filesavertext.setAttribute('for', MySaveAsFNtextfieldId);
    actionform.appendChild(filesavertext);
    var saveAs = document.createElement("input");
    saveAs.setAttribute("type", "submit");
    saveAs.value = "\u2193 save as";
    saveAs.setAttribute("tabindex", "104");
    filesavertext.appendChild(saveAs);
    saveAs.id = MySaveAsFNtextfieldId + "_savebutton";
    saveAs.setAttribute("name", saveAs.id);
    actionform.setAttribute("defaultbutton", saveAs.id);
    x = document.createElement("input");
    x.setAttribute("type", "text");
    
    x.setAttribute("tabindex", "105");
    x.id = MySaveAsFNtextfieldId;
    x.className = "filename";
    x.setAttribute("placeholder", defaultFileName);
    filesavertext.appendChild(x);
    filesavertext.appendChild(document.createTextNode("." + fileext));

    //x.innerHTML='<label>Filename: <input type="text" class="filename" placeholder=articleid>.bib<\/label><input type="submit" value="Save"><\/form>';
    actionform.addEventListener("submit",
        new Function('event',
            'event.preventDefault();' +
            'var fname=document.getElementById("' + MySaveAsFNtextfieldId + '");var fcontent=document.getElementById("' + MyDialogBodyId + '_rawtext");' +
            'saveAs(new Blob([fcontent.value],' +
            '{type:"'+mimetype+';charset='+document.characterSet+'"}),' +
            '(legalisestring(fname.value)||"'+defaultFileName+'") + ".' + fileext + '"' +
            ');'
        ),
        false);

    var x = document.createElement("input");
    x.setAttribute("type", "button");
    x.value = "\u21BB reload";
    x.addEventListener("click", new Function('event',
        'popUp("' + Title + '", decodeURIComponent("' + encodeURIComponent(thisText) + '"), "' + windowtitle + '", "' + articleid + '", "' + info + '", "' + displaymode + '", "' + element + '")'), false);
    x.setAttribute("tabindex", "106");
    actionform.appendChild(x);
    //closediv.style = "position:absolute;float:right;margin-left:12em";
    var close = document.createElement("input");
    close.setAttribute("type", "button");
    close.value = "\u2717 close";
    close.setAttribute("tabindex", "108");

    actionform.appendChild(close);




    //var footer = document.createElement("footer");
    //footer.appendChild(navarea);
    fullContent.appendChild(actionform);
    //footer.className = "dialogfooter";
    //fullContent.appendChild(footer);


    var main = document.createElement("div");
    //main.setAttribute("contenteditable", "true");
    main.className = "dialogbody";
    main.id = MyDialogBodyId;
    
    myviewport = document.createElement("div");
    myviewport.className="viewport";
	main.appendChild(myviewport);
	x= document.createElement("div");

	var copypastewarning=
	"(Concerning copy and paste:) You are recommended to switch to “<em>raw text view<\/em>” or use the “<em>save as<\/em>” function, since browsers behave quite differently when copying from formatted text. If you decide to use your <em>current<\/em> copy of formatted text, please check your pasted output for possibly misplaced elements.";
	
    //$(x).attr("contenteditable","true")
    $(x).addClass("formatted")
        .attr("id", MyDialogBodyId + "_formatted")
        //.attr("oncopy",'var x=showInfoBar(\''+copypastewarning+'\',1);setTimeout(\'showInfoBar(false,2,\\\''+copypastewarning +'\\\')\',20000)') 
        .attr("oncopy",'var x=showInfoBar(\''+copypastewarning+'\',1);setTimeout(\'showInfoBar(false,2,x)\',20000)') 
        .html(thisText);

  /*  $(x)
        .contents()
        .filter(function() {
            return this.nodeType === 3;
        })
        .wrap("<p></p>")
        .end()
        .filter("br")
        .remove();
*/
	
    myviewport.appendChild(x);

    /*for (var i = 0; i < 10; i++) {
        main.innerHTML += "<br>";
    }*/
    x.setAttribute("tabindex", 100);

	var mytextarea = document.createElement("textarea");
    mytextarea.className="rawtext";
    mytextarea.style.display="none";
    mytextarea.id = MyDialogBodyId + "_rawtext";
    mytextarea.setAttribute("oncopy","showInfoBar(false,2,'"+copypastewarning +"')");
    mytextarea.setAttribute("tabindex", 99);
    
    mytextarea.setAttribute("readonly", "readonly");
    myviewport.appendChild(mytextarea);
    


    //$(s).filter("dl dt dd ul li").wrap("\n").end()

 

    mytextarea.value = x.textContent; // (stringToBoolean(articleid)) ? (x.textContent) : (getText(x));
    fullContent.appendChild(main);
    //mytextarea.value=convert2raw(MyDialogBodyId);

    //main.setAttribute("origformatted", encodeURIComponent(thisText));
    //main.setAttribute("origrawtext", encodeURIComponent(mytextarea.value));



    //multiplechoice notyetfinished    if (!stringToBoolean(displaymode)) displaymode = 2;
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished    switch (displaymode) {
    //multiplechoice notyetfinished		/* case 4:
    //multiplechoice notyetfinished         
    //multiplechoice notyetfinished		var dialogbox = document.createElement("div");
    //multiplechoice notyetfinished            dialogbox.id = "dialog";
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            dialogbox.title=Title;
    //multiplechoice notyetfinished            dialogbox.innerHTML=thisText;
    //multiplechoice notyetfinished            document.body.insertBefore(dialogbox, document.getElementById("database"));
    //multiplechoice notyetfinished			$( "#dialog" ).dialog({width:"auto",height:"auto",maxWidth:"800",maxHeight:"500"});
    //multiplechoice notyetfinished			break;
    //multiplechoice notyetfinished		*/
    //multiplechoice notyetfinished        case 3: // new popup window/tab in browser
    //multiplechoice notyetfinished	//		alert(thisText);
    //multiplechoice notyetfinished          
    //multiplechoice notyetfinished          
    //multiplechoice notyetfinished          
    //multiplechoice notyetfinished            var x;
    //multiplechoice notyetfinished            var w = screen.availWidth / 2;
    //multiplechoice notyetfinished            var h = 2 * screen.availHeight / 3;
    //multiplechoice notyetfinished            var xx = screen.availWidth / 2 - w / 2;
    //multiplechoice notyetfinished            var yy = screen.availHeight / 2 - h / 2;
    //multiplechoice notyetfinished            var myWindow = window.open("", windowtitle, "target=_blank, dependent=yes, status=yes, resizable=yes, scrollbars=yes, width=" + w + ",height=" + h + ",left=" + xx + ",top=" + yy + ",screenX=" + xx + ",screenY=" + yy);
    //multiplechoice notyetfinished            //myWindow.document.removeElement('html','body');
    //multiplechoice notyetfinished            //myWindow.document.innerHTML="";
    //multiplechoice notyetfinished            close.setAttribute("onclick","window.close()");
    //multiplechoice notyetfinished            myWindow.document.open();
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            myWindow.document.write("<!DOCTYPE html><html><head>"+ 
    //multiplechoice notyetfinished            document.head.innerHTML +"<\/head><body>"+fullContent.innerHTML + "<\/body><\/html>");
    //multiplechoice notyetfinished            myWindow.document.close();
    //multiplechoice notyetfinished			//myWindow.document.appendChild(myWindow.document.createElement("body"));
    //multiplechoice notyetfinished            /*
    //multiplechoice notyetfinished            myWindow.document.write("<link href='css/bibmas_main.dev.css' rel='stylesheet' type='text/css'></head><body></body></html>");*/
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished           //myWindow.innerHTML="<html><head>" +  document.head.innerHTML + "<\/head><body><\/body><\/html>";
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished			
    //multiplechoice notyetfinished            myWindow.document.title = articleid + " - " + Title;
    //multiplechoice notyetfinished			//myWindow.document.write("<body>"+thisText+"<\/body>");
    //multiplechoice notyetfinished			
    //multiplechoice notyetfinished			/*
    //multiplechoice notyetfinished            var dialog = myWindow.document.createElement("dialog");
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            var header = myWindow.document.createElement("header");
    //multiplechoice notyetfinished            if (articleid != undefined)  {x = myWindow.document.createElement("code");
    //multiplechoice notyetfinished            x.textContent = "[" + articleid + "]";
    //multiplechoice notyetfinished            header.appendChild(x);}
    //multiplechoice notyetfinished            x = myWindow.document.createElement("h1");
    //multiplechoice notyetfinished            x.textContent = Title;
    //multiplechoice notyetfinished            header.appendChild(x);
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            dialog.appendChild(header);
    //multiplechoice notyetfinished		  
    //multiplechoice notyetfinished            var main = myWindow.document.createElement("div");
    //multiplechoice notyetfinished            main.id = "main_" + articleid;
    //multiplechoice notyetfinished            main.innerHTML = thisText;
    //multiplechoice notyetfinished            dialog.appendChild(main);
    //multiplechoice notyetfinished            dialog.appendChild(main);
    //multiplechoice notyetfinished            //var CloseButton=document.createElement("a href='javascript
    //multiplechoice notyetfinished			
    //multiplechoice notyetfinished            var navarea = myWindow.document.createElement("nav");
    //multiplechoice notyetfinished            x = myWindow.document.createElement("a");
    //multiplechoice notyetfinished            x.href = "javascript:slctT(document.getElementById('main_" + articleid + "'))";
    //multiplechoice notyetfinished            x.className = "button";
    //multiplechoice notyetfinished            x.textContent = "select all";
    //multiplechoice notyetfinished            x.tabindex = "1";
    //multiplechoice notyetfinished            navarea.appendChild(x);
    //multiplechoice notyetfinished            navarea.appendChild(myWindow.document.createTextNode("\n(hit "));
    //multiplechoice notyetfinished            x = myWindow.document.createElement("kbd");
    //multiplechoice notyetfinished            x.textContent = "Ctrl+C";
    //multiplechoice notyetfinished            x.tabindex = "0";
    //multiplechoice notyetfinished            navarea.appendChild(x);
    //multiplechoice notyetfinished            navarea.appendChild(myWindow.document.createTextNode(" to copy into clipboard)\n"));
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            x = myWindow.document.createElement("a");
    //multiplechoice notyetfinished            x.href = "javascript:window.close()";
    //multiplechoice notyetfinished            x.className = "button";
    //multiplechoice notyetfinished            x.textContent = "close";
    //multiplechoice notyetfinished            navarea.appendChild(x);
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            navarea.style = "position:absolute;float:right;right:2em;top:2em;";
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            myWindow.document.body.appendChild(dialog);
    //multiplechoice notyetfinished            myWindow.document.body.appendChild(navarea);
    //multiplechoice notyetfinished            //myWindow.document.write("<script src='bibmas_general.js' type='text/javascript'><\/script>");
    //multiplechoice notyetfinished            */
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            
    //multiplechoice notyetfinished            myWindow.focus();
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            break;
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished        default: // pseudo-dialogbox in same window/tab
    //multiplechoice notyetfinished
    closedialogbox(windowtitle);

    var outerDialg = document.createElement("div");

    outerDialg.id = windowtitle;
    outerDialg.className = "dialogWrapper";
    document.body.insertBefore(outerDialg, document.getElementById("infoBar"));
    //document.body.appendChild(outerDialg);
    var innerDialg = document.createElement("div");
    innerDialg.className = "dialogInner ";
    /*   switch (info) {
                case "titleset":
                case "biblatex":
                    innerDialg.className += "large";
                    break;
                default:
                    var maxLittle = 170;
                    maxMiddle = 170;
                    //maxMiddle = 1500;
                    var len = stripHTML(thisText).length;
                    if (len < maxLittle) innerDialg.className += "little";
                    else {
                        if (len < maxMiddle) innerDialg.className += "middle";
                        else innerDialg.className += "large";
                    }
            }
		*/
    innerDialg.id = windowtitle + "_inner";

    //outerDialg.className+=" dynDiv_moveDiv dynDiv_showResize-active";
    var childDiv = document.createElement("div");
    childDiv.className += " dynDiv_moveParentDiv dynDiv_showResize";
    //childDiv.textContent=Title;
    innerDialg.appendChild(childDiv);
    var resize1 = document.createElement("DIV");
    resize1.className = "dynDiv_resizeDiv_tl";
    innerDialg.appendChild(resize1);
    var resize2 = document.createElement("DIV");
    resize2.className = "dynDiv_resizeDiv_tr";
    innerDialg.appendChild(resize2);
    var resize3 = document.createElement("DIV");
    resize3.className = "dynDiv_resizeDiv_bl";
    innerDialg.appendChild(resize3);
    var resize4 = document.createElement("DIV");
    resize4.className = "dynDiv_resizeDiv_br";
    innerDialg.appendChild(resize4);
    outerDialg.appendChild(innerDialg);


    var xb = document.createElement("div");


    xb.className = "cbut";
    //xb.style = "display:block;position:absolute!important;size:auto;float:right!important;top:5px!important;right:5px!important;z-index:99";
    var xbb = document.createElement("a");
    xbb.href = "javascript:closedialogbox('" + windowtitle + "')";
    if (info && articleid) xbb.title = "Close " + info + " box for " + articleid;

    xbb.innerHTML = "&times;";
    xbb.setAttribute("tabindex", 109);
    xbb.style = xb.style;
    xbb.className = xb.className;
    xb.appendChild(xbb);

    innerDialg.appendChild(xb);

    /*
			
			//var newwindowdiv = document.createElement("span");
			var newwindow=document.createElement("button");
				//document.getElementById('info_" + articleid + "').textContent
			newwindow.addEventListener("click", new Function ('event',
				'popUp("'+Title+'", decodeURIComponent("'+encodeURIComponent(thisText)+'"), "'+windowtitle+'", "'+articleid+'", "'+info+'", 3, "'+element+'")'),false);
			
			newwindow.setAttribute("type","button");
			newwindow.textContent="new window";
			newwindow.setAttribute("tabindex","107");
			//newwindowdiv.appendChild(newwindow);
			actionform.insertBefore(newwindow,close);
			*/
    close.setAttribute("onclick", "closedialogbox('" + windowtitle + "')");


    innerDialg.appendChild(fullContent);


    $(innerDialg).keyup(function(e) {
        if (e.keyCode === 27) {
            var thiswindow = outerDialg.id;
            //alert("closing "+ thiswindow);
            closedialogbox(thiswindow);
            //       window.location.hash=articleid;
        }
    });



    $("#outerDialg").click(function(e) {
        var thiswindow = outerDialg.id;

        closedialogbox(thiswindow);
        //       window.location.hash=articleid;
    });
    // Prevent dialog closure when clicking the body of the dialog (overrides closing on clicking overlay)
    $('#innerDialg').click(function() {
        event.stopPropagation();
    });

    ByRei_dynDiv.add(childDiv);
    ByRei_dynDiv.add(resize1);
    ByRei_dynDiv.add(resize2);
    ByRei_dynDiv.add(resize3);
    ByRei_dynDiv.add(resize4);
    $(close).focus();
    //document.body.appendChild(dialog);

    //multiplechoice notyetfinished            break;
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished       /* case 1: // simple overlaying details > summary / aside tag, preferably to insert after this element
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            if (!element) element = document.getElementById(articleid).getElementsByClassName("infolinks")[0].getElementsByTagName("a")[0];
    //multiplechoice notyetfinished            //only for testing purpose!!
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            if (element.parentNode.tagName.toLowerCase() == "summary") {
    //multiplechoice notyetfinished                (element.parentNode.parentNode.getAttribute("open", "open")) ? element.parentNode.parentNode.removeAttribute("open"): element.parentNode.parentNode.setAttribute("open", "open")
    //multiplechoice notyetfinished                return;
    //multiplechoice notyetfinished            }
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            var NewElement = element.cloneNode(true); // copying element 
    //multiplechoice notyetfinished            var WholeTag = document.createElement("details"); //build empty  details tag
    //multiplechoice notyetfinished            var ElementTag = document.createElement("summary"); //build empty  summary tag
    //multiplechoice notyetfinished            ElementTag.appendChild(NewElement);
    //multiplechoice notyetfinished            WholeTag.appendChild(ElementTag); // move empty summary tag into details tag
    //multiplechoice notyetfinished            WholeTag.setAttribute("open", "open");
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            var TextTag = document.createElement("small"); //build empty  note tag
    //multiplechoice notyetfinished            TextTag.className = "infoboxtext";
    //multiplechoice notyetfinished            WholeTag.appendChild(TextTag); // move NOTE tag into details tag
    //multiplechoice notyetfinished            TextTag.style.width = "300!important";
    //multiplechoice notyetfinished            TextTag.innerHTML = thisText;
    //multiplechoice notyetfinished            var MyClass = "infoboxopen";
    //multiplechoice notyetfinished            if (WholeTag.className.indexOf(MyClass) < 0) {
    //multiplechoice notyetfinished                WholeTag.className += MyClass;
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished                element.parentNode.replaceChild(WholeTag, element); //  Moving whole details tag to original place
    //multiplechoice notyetfinished            }
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            //details_shim.init();
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            return WholeTag;
    //multiplechoice notyetfinished
    //multiplechoice notyetfinished            break;
    //multiplechoice notyetfinished		*/
    //multiplechoice notyetfinished    }

}



function closedialogbox(windowid) {
    if (!windowid.substr(0,windowPrefix.length)===windowPrefix) return; //if this is no window but another element, dont do anything
    x = document.getElementById(windowid);
    if (x) x.parentNode.removeChild(x);
};




